#include <iostream>
#include <cmath>

using namespace std;

typedef long long ll;

const ll t = 10000000, I = 45360;

ll a;

ll f(ll p){
    ll ans = 1;
    for (ll i = 2; i <= sqrt(p); i++){
        if (p % i == 0){
            ll r = 1;
            while (p % i == 0){
                r++;
                p /= i;
            }
            ans *= r;
        }
        if (p == 1)
            break;
    }
    if (p != 1)
        ans *= 2;
    return ans;
}

int main()
{
    cin >> a;
    if (a < t){
        for (int b = a; b <= a * 101 / 100; b++)
            if (f(b) >= 100){
                cout << b << endl;
                return 0;
            }
        cout << "-1\n";
        return 0;
    }
    if (a % I != 0)
        a += I - (a % I);
    cout << a << endl;
    return 0;
}
