#include <iostream>
#include <vector>
#include <fstream>

using namespace std;

int main()
{
	int n, m;
	cin >> n >> m;
	vector<vector<char>> a(n + 1), l(n + 1), r(n + 1), d(n + 1), u(n + 1);
	for (int i = 0; i < n; i++)
	{
		a[i].resize(m + 1);
		l[i].resize(m + 1);
		r[i].resize(m + 1);
		d[i].resize(m + 1);
		u[i].resize(m + 1);
	}
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			cin >> a[i][j];
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			if (i > 0 && a[i - 1][j] == a[i][j])
				u[i][j] = (i - 1) * m + j;
			else
				u[i][j] = i * m + j;
			if (j > 0 && a[i][j - 1] == a[i][j])
				l[i][j] = i * m + j - 1;
			else
				l[i][j] = i * m + j;
			if (i < n - 1 && a[i + 1][j] == a[i][j])
				d[i][j] = (i + 1) * m + j;
			else
				d[i][j] = i * m + j;
			if (j < m - 1 && a[i][j + 1] == a[i][j])
				r[i][j] = i * m + j + 1;
			else
				r[i][j] = i * m + j;
		}
	}
	int q;
	cin >> q;
	for (int t = 0; t < q; t++)
	{
		int x0, y0, ind1 = 0, ind2 = 0;
		cin >> x0 >> y0;
		x0--;
		y0--;
		vector<int> gor, ver;
		if (y0 < m - 1)
		{
			if (r[x0][y0 + 1] % m != m - 1)
				gor.push_back(r[x0][y0 + 1] + 1);
			gor.push_back(x0 * m + y0 + 1);
		}
		if (y0 > 0)
		{
			if (l[x0][y0 - 1] % m != 0)
				gor.push_back(l[x0][y0 - 1] - 1);
			gor.push_back(x0 * m + y0 - 1);
		}
		if (x0 > 0)
		{
			if (u[x0 - 1][y0] / m != 0)
				ver.push_back(u[x0 - 1][y0] - m);
			ver.push_back((x0 - 1) * m + y0);
		}
		if (x0 < n - 1)
		{
			if (d[x0 + 1][y0] / m != n - 1)
				ver.push_back(d[x0 + 1][y0] + m);
			ver.push_back((x0 + 1) * m + y0);
		}
		int min = LONG_MAX;
		for (int i = 0; i < gor.size(); i++)
			for (int j = 0; j < ver.size(); j++)
			{
				if (gor[i] == x0 * m + y0 || ver[j] == x0 * m + y0)
					continue;
				int x1 = gor[i] / m, y1 = gor[i] % m, x2 = ver[j] / m, y2 = ver[j] % m;
				if (a[x1][y1] == a[x2][y2])
					continue;
				if (abs(x1 - x2) + abs(y1 - y2) < min)
				{
					min = abs(x1 - x2) + abs(y1 - y2);
					ind1 = i;
					ind2 = j;
				}
			}
		if (min == LONG_MAX)
			cout << -1 << endl;
		else
		{
			int x1 = gor[ind1] / m, y1 = gor[ind1] % m, x2 = ver[ind2] / m, y2 = ver[ind2] % m;
			cout << x1 + 1 << ' ' << y1 + 1 << ' ' << x2 + 1 << ' ' << y2 + 1 << endl;
		}
	}
	return 0;
}