#include <iostream>
#include <cstdio>
#include <queue>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <cmath>

#define FAST_READ ios_base::sync_with_stdio(false);
#define in freopen("1.txt", "r", stdin);
#define out freopen("output.txt", "w", stdout);
#define MAXN 1000010
#define INF 2020202020
#define MOD 1000000007
#define pi 3.14159265358973238462643383
#define EPS 0.0000000000001
#define pb push_back

using namespace std;

typedef unsigned long long ull;
typedef int long long ll;
typedef long double ld;
typedef string str;
typedef pair < ll, ll > pr;

int n, m;
int x, y;
vector < string > s;
vector < vector < vector < int > > > a, b, c, d;
int q;

char *ss;

int main()
{
    FAST_READ
//    freopen ("input.txt","r",stdin);

    scanf ( "%d %d", &n, &m );
    s.resize ( n ); ss = new char[m];

    for ( int i = 0; i < n; ++ i )
    {
        scanf ( "%s", ss );
        s[i] = ss;
        //        cout << s[i] << endl;
    }

    a.resize ( n, vector < vector < int > > (m, vector < int > ( 27, -1 )) );
    b.resize ( n, vector < vector < int > > (m, vector < int > ( 27, -1 )) );
    c.resize ( n, vector < vector < int > > (m, vector < int > ( 27, -1 )) );
    d.resize ( n, vector < vector < int > > (m, vector < int > ( 27, -1 )) );


//    for ( int i = 0; i < n; ++ i )
//    {
//        for ( int j = 0; j < m; ++ j )
//        {
//            cout << c[i][j]['a'-'a'] << " ";
//        }
//        cout << endl;
//    }

    for ( int i = 0; i < n; ++ i )
    {
        vector < int > temp ( 27, -1 );
        for ( int j = 0; j < m; ++ j )
        {
            for ( int c = 'a'; c <= 'z'; ++ c )
            {
                if ( temp[c-'a'] != -1 )
                {
                    a[i][j][c-'a'] = j-temp[c-'a'];
                }
            }
            temp[s[i][j]-'a'] = j;

//            cout << s[i][j];
//            cout << a[i][j]['a'-'a'] << " ";
//            cout << a[i][j]['b'-'a'] << " ";
//            cout << a[i][j]['c'-'a'] << "  ";
//            cout << endl;
        }
//        cout << endl;
    }


    for ( int i = 0; i < n; ++ i )
    {
        vector < int > temp ( 27, -1 );
        for ( int j = m-1; j >= 0; -- j )
        {
            for ( int c = 'a'; c <= 'z'; ++ c )
            {
                if ( temp[c-'a'] != -1 )
                {
                    b[i][j][c-'a'] = temp[c-'a']-j;
                }
            }
            temp[s[i][j]-'a'] = j;

//            cout << s[i][j];
//            cout << a[i][j]['a'-'a'] << " ";
//            cout << a[i][j]['b'-'a'] << " ";
//            cout << a[i][j]['c'-'a'] << "  ";
//            cout << endl;
        }
//        cout << endl;
    }


    for ( int j = 0; j < m; ++ j )
    {
        vector < int > temp ( 27, -1 );
        for ( int i = 0; i < n; ++ i )
        {
            for ( int cc = 'a'; cc <= 'z'; ++ cc )
            {
                if ( temp[cc-'a'] != -1 )
                {
                    c[i][j][cc-'a'] = i-temp[cc-'a'];
                }
            }

            temp[s[i][j]-'a'] = i;

//            cout << s[i][j];
//            cout << c[i][j]['a'-'a'] << " ";
//            cout << c[i][j]['b'-'a'] << " ";
//            cout << c[i][j]['c'-'a'] << "  ";
//            cout << endl;
        }
//        cout << endl;
    }


    for ( int j = 0; j < m; ++ j )
    {
        vector < int > temp ( 27, -1 );
        for ( int i = n-1; i >= 0; -- i )
        {
            for ( int c = 'a'; c <= 'z'; ++ c )
            {
                if ( temp[c-'a'] != -1 )
                {
                    d[i][j][c-'a'] = temp[c-'a']-i;
                }
            }
            temp[s[i][j]-'a'] = i;

//            cout << s[i][j];
//            cout << a[i][j]['a'-'a'] << " ";
//            cout << a[i][j]['b'-'a'] << " ";
//            cout << a[i][j]['c'-'a'] << "  ";
//            cout << endl;
        }
//        cout << endl;
    }


//
//    for ( int i = 0; i < n; ++ i )
//    {
//        for ( int j = 0; j < m; ++ j )
//        {
//            cout << c[i][j]['a'-'a'] << " ";
//        }
//        cout << endl;
//    }
//
//
//


//    cout<<a[2][2][0]<<" "<<b[2][2][0]<<" "<<c[2][2][0]<<" "<<d[2][2][0]<<endl;
//    cout<<a[2][2][1]<<" "<<b[2][2][1]<<" "<<c[2][2][1]<<" "<<d[2][2][1]<<endl;

    scanf ( "%d", &q ); while ( q -- )
    {
        scanf ( "%d %d", &x, &y ); -- x; -- y;
        pair < int, int > mmx1, mmx2; int mdx = INF;

        for ( int ic = 0; ic <= 26; ++ ic )
        {
            for ( int jc = 0; jc <= 26; ++ jc )
            {
                if ( ic != jc )
                {
                    if ( a[x][y][ic] != -1 )
                    {
                        if ( c[x][y][jc] != -1 )
                        {
                            if ( a[x][y][ic] + c[x][y][jc] < mdx )
                            {
                                mdx = a[x][y][ic] + c[x][y][jc];
                                mmx1 = { x - c[x][y][jc], y };
                                mmx2 = { x, y - a[x][y][ic] };
                            }
                        }
                        if ( d[x][y][jc] != -1 )
                        {
                            if ( a[x][y][ic] + d[x][y][jc] < mdx )
                            {
                                mdx = a[x][y][ic] + d[x][y][jc];
                                mmx1 = { x + d[x][y][jc], y };       ////////////////////////////
                                mmx2 = { x, y - a[x][y][ic] };
                            }
                        }
                    }



                    if ( b[x][y][ic] != -1 )
                    {
                        if ( c[x][y][jc] != -1 )
                        {
                            if ( b[x][y][ic] + c[x][y][jc] < mdx )
                            {
                                mdx = b[x][y][ic] + c[x][y][jc];
                                mmx1 = { x - c[x][y][jc], y };
                                mmx2 = { x, b[x][y][ic] + y };
                            }
                        }
                        if ( d[x][y][jc] != -1 )
                        {
                            if ( b[x][y][ic] + d[x][y][jc] < mdx )
                            {
                                mdx = b[x][y][ic] + d[x][y][jc];
                                mmx1 = { d[x][y][jc] + x, y };
                                mmx2 = { x, b[x][y][ic] + y };
                            }
                        }
                    }
                }
            }
        }

        if ( mdx != INF )
        {
            printf ( "%d %d %d %d\n", mmx1.first+1, mmx1.second+1, mmx2.first+1, mmx2.second+1 );
        }
        else
        {
            printf ( "-1\n" );
        }

    }



    return 0;
}
