#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define pb push_back

const int N = (int)1e8;
const ll lim = (ll)1e16;

ll x;
int sqr[30000];
vector < int > v;
bitset < N + 1 > p;

ll gcd(ll a, ll b) {
	return (!b ? a : gcd(b, a % b));
}

ll bm(ll a, ll b, ll mod) {
	ll res = 0;
	while (b) {
		if (b & 1)
			res = (res + a) % mod;
		a = (a + a) % mod;
		b >>= 1;
	}
	return res;
}

ll bp(ll a, ll b, ll mod) {
	ll res = 1;
	while (b) {
		if (b & 1)
			res = bm(res, a, mod);
		a = bm(a, a, mod);
		b >>= 1;
	}
	return res;
}

bool check_pr(ll x) {
	for (int i = 0; i < 20; i++) {
		ll a;
		while (1) {
			a = rand();
			if (gcd(a, x) == 1)
				break;
		}
		if (bp(a, x - 1, x) != 1)
			return 0;
	}
	return 1;
}

int main() {
	srand(time(NULL));

	for (int i = 1; i <= 20000; i++)
		sqr[i] = i * i;

	for (int i = 4; i <= N; i += 2)
		p[i] = 1;

	for (int i = 3; sqr[i] <= N; i += 2)
		if (!p[i])
			for (int j = sqr[i]; j <= N; j += i * 2)
				p[j] = 1;

	for (int i = 2; i <= N; i++)
		if (!p[i])
			v.pb(i);

	cin >> x;

	ll y = x;

	while (x * 100 <= y * 100 && y * 100 <= x * 101) {
	    int cnt = 1;
	    ll z = y;
	    for (auto i : v) {
			if (i * 1ll * i * i > y)
				break;
			if (z % i == 0) {
				int cur = 0;
				while (z % i == 0) {
					cur++;
					z /= i;
				}
				cnt *= (cur + 1);
				if (cnt >= 100) {
					cout << y;
					return 0;
				}
			}
		}
		if (z != 1) {
			if (check_pr(z))
				cnt *= 2;
			else {
				ll SQRT = sqrt(z + 0.5);
				if (SQRT * SQRT == z)
					cnt *= 3;
				else
					cnt *= 4;
			}
		}
		if (cnt >= 100) {
			cout << y;
			return 0;
		}
		y++;
	}

	cout << -1;

	return 0;
}
