#include <bits/stdc++.h>
  
#define f first
#define s second
#define ll long long
#define pb push_back  

using namespace std;
  
void rf() {
    #define fn ""
    #ifdef SONY
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #else
        //freopen(fn".in", "r", stdin);
        //freopen(fn".out", "w", stdout);
    #endif //SONY   
}

const int MAXN = 1e6 + 1;
const double EPS = 1e-9;
bool np[MAXN];
vector<int> primes;

ll mult(ll x, ll y, ll mod) {
	ll res = 0;
	while (y) {
		if (y % 2) res = (res + x) % mod;
		x = (x + x) % mod;
		y /= 2;
	}
	return res;
}

ll bp(ll x, ll y, ll mod) {
	ll ret = 1;
	while (y) {
		if (y % 2) {
			ret = mult(ret, x, mod);
		}
		x = mult(x, x, mod);
		y /= 2;	
    }
    return ret;
}

bool prime(ll x) {
	if (x == 1) return false;
	if (x == 2) return true;
	for (auto it : primes) if (x != it && x % it == 0) return false;
	for (int i = 1; i <= 200; i++) {
		ll a = rand() % (x - 2) + 2;
		if (__gcd(a, x) != 1) return false;
		if (bp(a, x - 1, x) != 1) return false;
	}
	return true;
}
  
bool ok(ll x) {
    int ans = 1;
    for (auto it : primes) {
    	int pw = 0;
    	while (x % it == 0) {
    		pw++;
    		x /= it;
    	}
    	ans *= pw + 1;
    	if (ans >= 100) return true;
    }
    if (x > 1) {
    ll sq = sqrt(x) + EPS;
    if (sq * sq == x) {
    	ans *= 3;
    } else if (prime(x)) {
    	ans *= 2;
    } else {
    	ans *= 4;
    }
    }
    //cout << ans << endl;
    return (ans >= 100);
}

void sieve() {
	for (int i = 2; i < MAXN; i++) {
		if (!np[i]) {
			if (i * 1ll * i < MAXN) {
				for (int j = i * i; j < MAXN; j += i) {
					 np[j] = 1;
				}
			}
			primes.pb(i);
		}
	}
}
  
int main() {
    srand(time(0));
    rf();
    sieve();
    //ok(1000000000030720);
    //return 0;

    ll x;
    cin >> x;

    ll till = x * 1.01 + (1e-9);
    for (; x <= till; x++) {
        if (ok(x)) {
        	cout << x;
            return 0;
        }
    }
    cout << -1;
    return 0;
}