#ifdef _DEBUG
# include <iostream>
# include <vector>
# include <string>
#else
#include <bits/stdc++.h>
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = (int)1e9 + 7;

int main()
{
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
#endif

  int h, w, n;
  cin >> h >> w >> n;

  string s;
  cin >> s;

  vector<int> a, b, c, d;
  int k;

  cin >> k;
  a.resize(k);
  for (int i = 0; i < k; i++)
	cin >> a[i];
  for (int i = k; i < n; i++)
	a.push_back(((ll)a[i - 1] * 10007 + (ll)a[i - 2] * 10009 + 87277) % h);

  cin >> k;
  b.resize(k);
  for (int i = 0; i < k; i++)
	cin >> b[i];
  for (int i = k; i < n; i++)
	b.push_back(((ll)b[i - 1] * 10007 + (ll)b[i - 2] * 10009 + 87277) % w);

  cin >> k;
  c.resize(k);
  for (int i = 0; i < k; i++)
	cin >> c[i];
  for (int i = k; i < n; i++)
	c.push_back(((ll)c[i - 1] * 10007 + (ll)c[i - 2] * 10009 + 87277) % h);

  cin >> k;
  d.resize(k);
  for (int i = 0; i < k; i++)
	cin >> d[i];
  for (int i = k; i < n; i++)
	d.push_back(((ll)d[i - 1] * 10007 + (ll)d[i - 2] * 10009 + 87277) % w);

  vector<vector<int>> A(h, vector<int>(w));
  for (int i = 0; i < h; i++)
	for (int j = 0; j < w; j++)
	  A[i][j] = i * w + j;

  vector<int> B(h), C(w);

  for (int i = 0; i < h; i++)
	B[i] = i;
  for (int i = 0; i < w; i++)
	C[i] = i;

  for (int i = 0; i < s.size(); i++)
	if (s[i] == 'c')
	{
	  swap(C[b[i]], C[d[i]]);
	}
	else if (s[i] == 'r')
	{
	  swap(B[a[i]], B[c[i]]);
	}
	else
	{
	  swap(A[B[a[i]]][C[b[i]]], A[B[c[i]]][C[d[i]]]);
	}

  ll res = 0, p = 1;
  for (int i = 0; i < h; i++)
  {
	ll q = 1;
	for (int j = 0; j < w; j++)
	{
	  res = (res + ((ll)A[B[i]][C[j]] * p) % INF * q) % INF;
	  q = (q * 19) % INF;
	}
	p = (p * 17) % INF;
  }

  cout << res << endl;
}