#include <bits/stdc++.h>

using namespace std;

typedef pair<int, int> pii;

const int INF = 1e7;
const int SZ = 1e6;

int dpu[26][SZ];
int dpl[26][SZ];
int dpd[26][SZ];
int dpr[26][SZ];
    


void get_ans(int n)
{
    int m;
    scanf("%d", &m);
    int field[n][m];
    for (int i = 0; i < n; ++i)
    {
        string s;
        cin >> s;
        for (int j = 0; j < m; ++j)
            field[i][j] = s[j] - 'a';
    }
    for (int k = 0; k < 26; ++k)
    {
        for (int i = 0; i < n; ++i)
            for (int j = 0; j < m; ++j)
            {
                if (i == 0)
                    dpu[k][i * m + j] = INF;
                else if (field[i - 1][j] == k)
                    dpu[k][i * m + j] = 1;
                else
                    dpu[k][i * m + j] = dpu[k][(i - 1) * m + j] + 1;                    
            }    
    }
    for (int k = 0; k < 26; ++k)
    {
        for (int i = n - 1; i >= 0; --i)
            for (int j = 0; j < m; ++j)
            {
                if (i == n - 1)
                    dpd[k][i * m + j] = INF;
                else if (field[i + 1][j] == k)
                    dpd[k][i * m + j] = 1;
                else
                    dpd[k][i * m + j] = dpd[k][(i + 1) * m + j] + 1;                    
            }    
    }
    for (int k = 0; k < 26; ++k)
    {
        for (int i = 0; i < n; ++i)
            for (int j = 0; j < m; ++j)
            {
                if (j == 0)
                    dpl[k][i * m + j] = INF;
                else if (field[i][j - 1] == k)
                    dpl[k][i * m + j] = 1;
                else
                    dpl[k][i * m + j] = dpl[k][i * m + j - 1] + 1;                    
            }    
    }
    for (int k = 0; k < 26; ++k)
    {
        for (int i = 0; i < n; ++i)
            for (int j = m - 1; j >= 0; --j)
            {
                if (j == m - 1)
                    dpr[k][i * m + j] = INF;
                else if (field[i][j + 1] == k)
                    dpr[k][i * m + j] = 1;
                else
                    dpr[k][i * m + j] = dpr[k][i * m + j + 1] + 1;                    
            }    
    }       
    int q;
    scanf("%d", &q);
    for (int i = 0; i < q; ++i)
    {
        int x, y;     
        scanf("%d %d", &x, &y);
        --x, --y;                        
        int mi1 = -1, mi2 = -1, minans1 = 2 * INF + 2, minans2 = 2 * INF + 2;
        for (int k = 0; k < 26; ++k)
        {
            int now = min(dpu[k][x * m + y], dpd[k][x * m + y]);
            if (now <= minans1)
            {
                mi2 = mi1;
                mi1 = k;
                minans2 = minans1;
                minans1 = now;
            }
            else if (now <= minans2)
            {
                mi2 = k;
                minans2 = now;
            }
              
        }  
        int u1 = mi1, u2 = mi2, ua1 = minans1, ua2 = minans2;
        mi1 = -1, mi2 = -1, minans1 = 2 * INF + 2, minans2 = 2 * INF + 2;
        for (int k = 0; k < 26; ++k)
        {
            int now = min(dpl[k][x * m + y], dpr[k][x * m + y]);
            if (now <= minans1)
            {
                mi2 = mi1;
                mi1 = k;
                minans2 = minans1;
                minans1 = now;
            }
            else if (now <= minans2)
            {
                mi2 = k;
                minans2 = now;
            }                 
        }  
        int ansu, ansr;
        int r1 = mi1, r2 = mi2, ra1 = minans1, ra2 = minans2;
        if (r1 != u1)
            ansu = u1, ansr = r1;
        else if (ra1 + ua2 > ra2 + ua1)
            ansu = u1, ansr = r2;
        else           
            ansu = u2, ansr = r1;
        int ans = min(dpl[ansr][x * m + y], dpr[ansr][x * m + y]) + min(dpu[ansu][x * m + y], dpd[ansu][x * m + y]);
        if (ans >= INF)
            printf("-1\n");
        else
        {
            int up = dpd[ansu][x * m + y];
            if (dpd[ansu][x * m + y] > dpu[ansu][x * m + y])
                up = -dpu[ansu][x * m + y];    
            int left = dpr[ansr][x * m + y];
            if (dpr[ansr][x * m + y] > dpl[ansr][x * m + y])
                left = -dpl[ansr][x * m + y];    
            printf("%d %d %d %d\n", x + 1 + up, y + 1, x + 1, y + 1 + left);
        }
    }
}

int main()
{                                                     
//    freopen("1.in", "r", stdin);
//    freopen("1.out", "w", stdout);
    int n;
    while (scanf("%d", &n) == 1)
        get_ans(n);
    return 0;
}