import java.io.*;
import java.util.Locale;
import java.util.StringTokenizer;

public class A {
//    String fileName = "<name>";

    public boolean cmp(long a, long b, long c, long mod)
    {
        return ((b - a + mod) % mod <= (c - a + mod) % mod);
    }

    public void solve() throws IOException {
        long x = nextLong();
        long m = nextInt();
        long l = x - m;
        long mod = 1000000000000000000L - m;
        long r = Math.min(x, mod - m) + 1;
        if (l + 1 == r) {
            out.println("? " + l);
            out.flush();
            long y = nextLong();
            out.println("? " + r);
            out.flush();
            long y2 = nextLong();
            if (y == x) {
                out.println("! " + l);
                out.flush();
            } else if (y2 == x) {
                out.println("! " + r);
                out.flush();
            } else {
                out.println("! -1");
                out.flush();
            }
            return;
        }
        out.println("? " + 1);
        out.flush();
        long delt = nextLong();
        if (delt == x) {
            out.println("! 1");
            out.flush();
            return;
        }
        /*System.out.println(l);
        System.out.println(r);
        System.out.println(delt);*/
        l = (l - delt + mod) % mod;
        long p = l;
        r = (r - delt + mod) % mod + 1;
        long ans = -1;
        while (l + 1 != r) {
            long s = ((l + r) / 2) % mod;
            if ((l + r) / 2 >= mod)
                ++s;
            out.println("? " + s);
            out.flush();
//            System.out.println(l+" "+r);
            long y = nextLong();
            boolean b = cmp(delt, y, x, mod);
            if (!b) {
                r = s;
            } else {
                if (y == x) {
                    ans = s;
                    break;
                }
                l = s;
            }
        }
        if (ans == -1 && l != p) {
            out.println("? " + l);
            out.flush();
            long y = nextLong();
            if (y == x) {
                ans = l;
            }
        }
        out.println("! " + ans);
        out.flush();

        // write your code here
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new A().run();
    }

}