#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>
#include <set>

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	int n, k, m;
	cin >> n >> k >> m;
	vector<int> a(m);
	for (int i = 0; i < m; i++){
		cin >> a[i];
	}
	sort(a.begin(), a.end());
	vector<int> dp(m);
	for (int i = m - 1; i >= 0; i--){
		int l = i, r = m - 1;
		while (l != r){
			int mid = (l + r + 1) / 2;
			if (a[i] + k - 1 >= a[mid])
				l = mid;
			else
				r = mid - 1;
		}
		if (l == m - 1){
			dp[i] = min(k, n - a[i] + 1);
		}
		else
			dp[i] = k + dp[l + 1];
	}
	int mn = dp[0];
	for (int i = 0; i < m - 1; i++){
		if (a[i] < k){
			mn = min(mn, dp[i + 1] + a[i]);
		}
	}
	if(a[m - 1] < k)
	mn = min(mn, a[m - 1]);
	cout << n - mn;
	return 0;
}
