#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>
#include <set>
#include <string>

using namespace std;

int main() {
	ios_base::sync_with_stdio(false);
	int h, w;
	cin >> h >> w;
	vector < vector < int > > mn(h, vector <int>(w));
	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j++) {
			mn[i][j] = i * w + j;
		}
	}
	vector < int > vr(w), hr(h);
	for (int i = 0; i < h; i++)
		hr[i] = i;
	for (int i = 0; i < w; i++)
		vr[i] = i;
	int q;
	cin >> q;

	string s;
	cin >> s;

	vector < long long > A(q), B(q), C(q), D(q);
	
	int k;
	cin >> k;
	for (int i = 0; i < q; i++) {
		if (i < k)
			cin >> A[i];
		else
			A[i] = (10007 * A[i - 2] + 10009 * A[i - 1] + 87277) % h;
	}
	cin >> k;
	for (int i = 0; i < q; i++) {
		if (i < k)
			cin >> B[i];
		else
			B[i] = (10007 * A[i - 2] + 10009 * B[i - 1] + 87277) % w;
	}
	cin >> k;
	for (int i = 0; i < q; i++) {
		if (i < k)
			cin >> C[i];
		else
			A[i] = (10007 * C[i - 2] + 10009 * C[i - 1] + 87277) % h;
	}
	cin >> k;
	for (int i = 0; i < q; i++) {
		if (i < k)
			cin >> D[i];
		else
			A[i] = (10007 * D[i - 2] + 10009 * D[i - 1] + 87277) % w;
	}

	for (int e = 0; e < q; e++) {
		char c = s[e];
		if (c == 'c') {
			long long x, y;
			x = B[e], y = D[e];
			swap(vr[x], vr[y]);
		}
		if (c == 'r') {
			long long x, y;
			x = A[e], y = C[e];
			swap(hr[x], hr[y]);
		}
		if (c == 'f') {
			long long a, b, c, d;
			a = A[e], b = B[e], c = C[e], d = D[e];
			a = hr[a], b = vr[b], c = hr[c], d = vr[d];
			swap(mn[a][b], mn[c][d]);
		}
	}
	long long ans = 0;
	long long md = 1e9 + 7;
	vector < long long > pw17(5001, 1), pw19(5001, 1);
	for (long long i = 0, pw17 = 1; i < h; i++, pw17 *= 17, pw17 %= md) {
		for (long long j = 0, pw19 = 1; j < w; j++, pw19 *= 19, pw19 %= md) {
			ans += ((mn[hr[i]][vr[j]] * pw17) % md * pw19) % md;
			ans %= md;
			if (ans < 0)
				ans += md;
		}
	}
	cout << ans;
	return 0;
}