#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>
#include <set>

using namespace std;

long long INF = 1e18;

long long ask(long long v){
	cout << "? " << v << endl;
	long long res;
	cin >> res;
	return res;
}

int main() {
	ios_base::sync_with_stdio(false);
	long long x;
	int m;
	cin >> x >> m;
	long long get = ask(1);
	if (x == get){
		cout << "! 1" << endl;
		return 0;
	}
	if (x > get){
		INF -= m;
	}
	long long l = INF + x - get - m + 1, r = INF + x - get + 2;
	if (x < get){
		INF -= m;
	}
	while (l < 0 || r < 0){
		l += INF;
		r += INF;
	}
	long long last = -1;
	while (l != r){
		long long mid = (l + r) / 2;
		get = ask(((mid - 1) % INF) + 1);
		if (get == x) {
			cout << "! " << ((mid - 1) % INF) + 1 << endl;
			return 0;
		}
		if (get > x){
			if (abs(get - x) > 1e17){
				l = mid + 1;
			}
			else{
				r = mid;
				last = get;
			}
		}
		else{
			if (abs(get - x) > 1e17){
				r = mid;
				last = get;
			}
			else
				l = mid + 1;
		}
	}
	l = ((l - 1) % INF) + 1;
		if (last == x){
			cout << "! " << l << endl;
			return 0;
		}
	cout << -1 << endl;
	return 0;
}