#include<bits/stdc++.h>

using namespace std;

int n, m;

const int INF = 1000000000;

void print(int a, int b, int c, int d)
{
    if (a == 0)
    {
        a = 2;
    }
    if (b == 0)
    {
        b = 2;
    }
    if (c == 0)
    {
        c = 2;
    }
    if (d == 0)
    {
        d = 2;
    }


    if (a == n - 1)
    {
        a = n - 3;
    }
    if (b == m - 1)
    {
        b = m - 3;
    }
    if (c == n - 1)
    {
        c = n - 3;
    }
    if (d == m - 1)
    {
        d = m - 3;
    }
    cout << a << " " << b << " " << c << " " << d << endl;
}

int min4(int a, int b, int c, int d)
{
    return min(min(a, b), min(c, d));
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    vector < vector < char > > mass(n + 2, vector < char >(m + 2));
    vector < vector < int > > dpd(n + 2, vector < int >(m + 2));
    vector < vector < int > > dpu(n + 2, vector < int >(m + 2));
    vector < vector < int > > dpl(n + 2, vector < int >(m + 2));
    vector < vector < int > > dpr(n + 2, vector < int >(m + 2));
    n += 2;
    m += 2;
    for (int i = 1; i < n - 1; i++)
    {
        for (int j = 1; j < m - 1; j++)
        {
            cin >> mass[i][j];
        }
    }
    for (int i = 0; i < n; ++i)
    {
        mass[i][0] = mass[i][2];
        mass[i][m - 1] = mass[i][m - 3];
    }
    for (int i = 0; i < m; ++i)
    {
        mass[0][i] = mass[2][i];
        mass[n - 1][i] = mass[n - 3][i];
    }
    for (int i = 0; i < n; i++)
    {
        dpl[i][0] = 1000000000;
        for (int j = 1; j < m; j++)
        {
            if (mass[i][j] == mass[i][j - 1])
            {
                dpl[i][j] = dpl[i][j - 1] + 1;
            }
            else
            {
                dpl[i][j] = 1;
            }
        }
    }
    for (int i = 0; i < n; i++)
    {
        dpr[i][m - 1] = 1000000000;
        for (int j = m - 2; j >= 0; j--)
        {
            if (mass[i][j] == mass[i][j + 1])
            {
                dpr[i][j] = dpr[i][j + 1] + 1;
            }
            else
            {
                dpr[i][j] = 1;
            }
        }
    }
    for (int j = 0; j < m; j++)
    {
        dpu[0][j] = 1000000000;
        for (int i = 1; i < n; i++)
        {
            if (mass[i - 1][j] == mass[i][j])
            {
                dpu[i][j] = dpu[i - 1][j] + 1;
            }
            else
            {
                dpu[i][j] = 1;
            }
        }
    }
    for (int j = 0; j < m; j++)
    {
        dpd[n - 1][j] = 1000000000;
        for (int i = n - 2; i >= 0; i--)
        {
            if (mass[i + 1][j] == mass[i][j])
            {
                dpd[i][j] = dpd[i + 1][j] + 1;
            }
            else
            {
                dpd[i][j] = 1;
            }
        }
    }
    swap(dpr, dpd);
    swap(dpl, dpu);
    int q;
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        int xi, yi;
        cin >> xi >> yi;
        if (mass[xi - 1][yi] != mass[xi][yi - 1])
        {
            print(xi - 1, yi, xi, yi - 1);
        }
        else if (mass[xi + 1][yi] != mass[xi][yi - 1])
        {
            print(xi + 1, yi, xi, yi - 1);
        }
        else if (mass[xi - 1][yi] != mass[xi][yi + 1])
        {
            print(xi - 1, yi, xi, yi + 1);
        }
        else if (mass[xi + 1][yi] != mass[xi][yi + 1])
        {
            print(xi + 1, yi, xi, yi + 1);
        }
        else
        {
            if (dpu[xi][yi - 1] == min4(dpl[xi - 1][yi], dpd[xi][yi + 1], dpr[xi + 1][yi], dpu[xi][yi - 1]))
            {
                if (dpu[xi][yi - 1] >= INF)
                {
                    cout << -1 << endl;
                    continue;
                }
                print(xi, yi - dpu[xi][yi - 1] - 1, xi + 1, yi);
            }
            else if (dpd[xi][yi + 1] == min4(dpl[xi - 1][yi], dpd[xi][yi + 1], dpr[xi + 1][yi], dpu[xi][yi - 1]))
            {
                if (dpd[xi][yi + 1] >= INF)
                {
                    cout << -1 << endl;
                    continue;
                }
                print(xi, yi + dpu[xi][yi + 1] + 1, xi + 1, yi);
            }
            else if (dpl[xi - 1][yi] == min4(dpl[xi - 1][yi], dpd[xi][yi + 1], dpr[xi + 1][yi], dpu[xi][yi - 1]))
            {
                if (dpl[xi - 1][yi] >= INF)
                {
                    cout << -1 << endl;
                    continue;
                }
                print(xi - dpl[xi - 1][yi] - 1, yi, xi, yi - 1);
            }
            else
            {
                if (dpr[xi + 1][yi] >= INF)
                {
                    cout << -1 << endl;
                    continue;
                }
                print(xi + dpr[xi + 1][yi] + 1, yi, xi, yi - 1);
            }
        }
    }
    /*cout << endl;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            cout << mass[i][j] << " ";
        }
        cout << endl;
    }
    cout << endl;
    cout << endl;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            cout << dpu[i][j] << " ";
        }
        cout << endl;
    }
    cout << endl;
    cout << endl;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            cout << dpd[i][j] << " ";
        }
        cout << endl;
    }
    cout << endl;
    cout << endl;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            cout << dpl[i][j] << " ";
        }
        cout << endl;
    }
    cout << endl;
    cout << endl;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            cout << dpr[i][j] << " ";
        }
        cout << endl;
    }
    cout << endl;*/
}

/*
3 4
abbb
baab
babb
*/
