#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <deque>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 1e5;
const ll LINF = 1e18 + 1e15;
const ld EPS = 1e-7;
const ll MOD = 1e9 + 7;

const int N = (int) 4e5 + 123;

ll cntdels(ll a) {
	ll ans = 0;
	for (ll i = 1; i*i <= a; i++) {
		if (i*i == a) ans++;
		else if (a%i == 0) ans += 2;
	}
	return ans;
}

int run() {
	ll x;
	cin >> x;
	ll ost = x % 45360;
	if (100LL *(x + (45360LL - ost)) <= 101LL*(x)) {
		cout << (x + (45360LL - ost));
	}
	else {
		ll i = x;
		while (100 * i <= 101 * x) {
			if (cntdels(i) >= 100) {
				cout << i;
				return 0;
			}
			i++;
		}
		cout << -1;
	}
	return 0;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nok";
	while (1);
#endif
	return 0;
}