#include <stdio.h>
#include <bits/stdc++.h>

#define ll long long
#define rep(i, l, r) for (int i = l; i < r; i++)

using namespace std;

const int INF = (int)1e9 + 7;
int kek = 26;

int main()
{
    freopen("a.in", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<vector<pair<int, int> > > > gor(n, vector<vector<pair<int, int> > > (m, vector<pair<int, int> > (kek, {INF, INF} )));
    vector<vector<vector<pair<int, int> > > > vert(m, vector<vector<pair<int, int> > > (n, vector<pair<int, int> > (kek, {INF, INF} )));
    vector<vector<char> > s(n, vector<char> (m));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> s[i][j];
    for (int i = 0; i < n; i++){
        vector<int> dist1(26, INF);
        for (int j = 0; j < m; j++){
            for (int k = 0; k < 26; k++){
                if (dist1[k] != INF){
                    gor[i][j][k].first = j - dist1[k];
                    gor[i][j][k].second = dist1[k];
                }
            }
            dist1[int(s[i][j] - 'a')] = j;
        }
        vector<int> dist2(26, INF);
        for (int j = m - 1; j >= 0; j--){
            for (int k = 0; k < 26; k++){
                if (dist2[k] != INF){
                    if (dist2[k] - j < gor[i][j][k].first){
                        gor[i][j][k].first = dist2[k] - j;
                        gor[i][j][k].second = dist2[k];
                    }
                }
            }
            dist2[int(s[i][j] - 'a')] = j;
        }
    }
    for (int i = 0; i < m; i++){
        vector<int> dist1(26, INF);
        for (int j = 0; j < n; j++){
            for (int k = 0; k < 26; k++){
                if (dist1[k] != INF){
                    vert[i][j][k].first = j - dist1[k];
                    vert[i][j][k].second = dist1[k];
                }
            }
            dist1[int(s[j][i] - 'a')] = j;
        }
        vector<int> dist2(26, INF);
        for (int j = n - 1; j >= 0; j--){
            for (int k = 0; k < 26; k++){
                if (dist2[k] != INF){
                    if (dist2[k] - j < vert[i][j][k].first){
                        vert[i][j][k].first = dist2[k] - j;
                        vert[i][j][k].second = dist2[k];
                    }
                }
                dist2[int(s[j][i] - 'a')] = j;
            }
        }
    }
    int q;
    cin >> q;
    for (int k = 0; k < q; k++){
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        int v1 = 0;
        int v2 = 0;
        int u1 = 0;
        int u2 = 0;
        for (int i = 0; i < 26; i++){
            if (gor[x][y][i].first <= gor[x][y][v1].first){
                v2 = v1;
                v1 = i;
                continue;
            }
            if (gor[x][y][i].first < gor[x][y][v2].first){
                v2 = i;
                continue;
            }
        }
        for (int i = 0; i < 26; i++){
            if (vert[y][x][i].first <= vert[y][x][u1].first){
                u2 = u1;
                u1 = i;
                continue;
            }
            if (vert[y][x][i].first < vert[y][x][u2].first){
                u2 = i;
                continue;
            }
        }
        if (v1 != u1 && gor[x][y][v1].first != INF && vert[y][x][u1].first != INF){
            cout << x + 1 << " " << v1 + 1 << " " << u1 + 1 << " " << y + 1 << "\n";
            continue;
        }
        else{
            if (gor[x][y][v1].first + vert[y][x][u2].first < gor[x][y][v2].first + vert[y][x][u1].first){
                if (gor[x][y][v1].first != INF && vert[y][x][u2].first != INF){
                    cout << x + 1 << " " << v1 + 1 << " " << u2 + 1 << " " << y + 1 << "\n";
                    continue;
                }
            }
            else
                if (gor[x][y][v2].first != INF && vert[y][x][u1].first != INF){
                    cout << x + 1 << " " << v2 + 1 << " " << u1 + 1 << " " << y + 1 << "\n";
                    continue;
                }
        }
        cout << -1 << endl;
    }
    return 0;
}
