#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <utility>
#include <fstream>
#include <sstream>

using namespace std;


int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
#endif
	//srand(time(NULL));

	vector<long long> nums;

	for (int i = 100; i <= 1000000; i++)
	{
		int res = 2;
		for (int j = 2; j * j <= i; j++)
		{
			if (j * j == i)
			{
				res++;
			}
			else if (i % j == 0)
			{
				res += 2;
			}
		}
		if (res >= 100)
		{
			nums.push_back(i);
			if (nums.size() > 300)
			{
				break;
			}
		}
	}

	long long x;
	cin >> x;

	for (long long n : nums)
	{
		long long l = 0, r = 1e12;
		while (r - l > 1)
		{
			long long m = (l + r) / 2;
			if (n * m < x)
			{
				l = m;
			}
			else
			{
				r = m;
			}
		}

		if (n * r >= x && n * r <= x + x / 100)
		{
			cout << n * r;
			return 0;
		}
	}


	cout << -1;

	
	return 0;
}