#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

const int INF = 1e9 + 7;

int bin_search(vector<int> &d, int v) {
	int l = 0, r = d.size();
	while (r - l > 1) {
		int m = (r + l) / 2;
		if (d[m] <= v) {
			l = m;
		}
		else {
			r = m;
		}
	}
	return l;
}

int main() {
	int n, m, k;
	cin >> n >> k >> m;
	vector<int> d(m);
	for (int i = 0; i < m; i++) {
		cin >> d[i];
		//d[i]--;
	}
	sort(d.begin(), d.end());
	d.push_back(n + 1);
	vector< vector <int> > dp(m + 1, vector<int>(2, INF));

	dp[0][0] = 0;
	int x = bin_search(d, d[0] + k - 1);
	dp[x][1] = min(INF, dp[0][0] + k);

	dp[0][1] = min(k, d[0]);
	for (int i = 1; i < m; i++) {
		dp[i][0] = dp[i - 1][1];
		x = bin_search(d, d[i] + k - 1);
		dp[x][1] = min(dp[x][1], dp[i][0] + min(k, n - d[i] + 1));
	}
	cout << n - min(dp[m - 1][1], dp[m][1]);
	return 0;
}
