import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.lang.reflect.Array;
import java.util.*;

/**
 * Created by orspc on 11.12.2016.
 */
public class mark {
    class Point implements Comparable<Point> {
        int N, type, x;

        public Point(int N, int type, int x) {
            this.N = N;
            this.type = type;
            this.x = x;
        }

        @Override
        public int compareTo(Point s) {
            if (x == s.x) {
                if (type == s.type) {
                    return 0;
                } else return type - s.type;
            } else return x - s.x;
        }
    }

    int n, m, k;

    public void solve() throws IOException {
        n = nextInt();
        m = nextInt();
        k = nextInt();
        int isEm = m - 1;
        Point line[] = new Point[2 * k];
        int a[] = new int[k];
        int b[] = new int[k];

        for (int i = 0; i < k; i++) {
            a[i] = nextInt();
            b[i] = nextInt();
            line[2 * i] = new Point(i, 1, a[i]);
            line[2 * i + 1] = new Point(i, 0, b[i]);
        }
        Arrays.sort(line);
        int isNear[] = new int[k];
        Arrays.fill(isNear, -1);

        TreeSet<Integer> bus = new TreeSet<>();
        for (int i = 1; i <= m; i++) bus.add(i);

        int res[] = new int[m + 1];

        for (int i = 0; i < 2 * k; i++) {
            if (line[i].type == 1) {
                if (isEm > 0) {
                    isEm--;
                    isNear[line[i].N] = 0;
                } else if (bus.size() > 0) {
                    int pos = bus.first();
                    bus.remove(pos);
                    isNear[line[i].N] = pos;
                    res[pos] += b[line[i].N] - a[line[i].N];
                }
            } else {
                if (isNear[line[i].N] == 0) {
                    isEm++;
                } else if (isNear[line[i].N] != -1) {
                    bus.add(isNear[line[i].N]);
                    isNear[line[i].N] = -1;
                }
            }
        }
        int min = Integer.MAX_VALUE, id = 0;
        for (int i = 1; i <= m; i++) {
            if (min > res[i]) {
                min = res[i];
                id = i;
            }
        }
        out.print(min + " " + id);


    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (IOException e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new mark().run();
    }
}
