#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>
#include <map>
#include <bitset>
#include <string>
#include <string>

using namespace std;

typedef long long ll;

int solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
}

int solve() {
	int t;
	cin >> t;

	while (t--) {
		ll a, n;
		cin >> a >> n;

		ll cur = 0;

		while (1) {

			int l1 = -1, l2 = -1;

			for (int i = 0; i < 60; i++) {
				if (a & (1ll << i))
					l1 = i;
			}

			for (int i = 0; i < 60; i++) {
				if (n & (1ll << i))
					l2 = i;
			}

			if (l1 == -1 || l2 == -1) break;

			if (l1 < l2) break;

			int t = l1 - l2;

			a ^= (n << t);
		}

		cout << a << "\n";
	}
	return 0;
}