#include <bits/stdc++.h>

using namespace std;

const int INF = (int)1e9 + 7;
const int N = (int)1e6;

int n, m, k;
vector<int> L[N], R[N];
int cnt[N], A[N], B[N], sum[N];

int main() {
    ios_base::sync_with_stdio(false);

    cin >> n >> m >> k;

    for (int i = 0; i < k; ++i)
    {
        int l, r;
        cin >> l >> r;
        L[l - 1].push_back(i);
        R[r - 1].push_back(i);
        cnt[i] = r - l;
    }

    set<int> pos1, pos2;

    for (int i = 0; i < m - 1; ++i)
        pos1.insert(i), pos2.insert(i);

    pos2.insert(m - 1);

    memset(A, -1, sizeof(A));
    memset(B, -1, sizeof(B));

    for (int i = 0; i < N; ++i)
    {
        for (auto j : R[i])
        {
            if (A[j] != -1)
                pos1.insert(A[j]);
            else
                pos2.insert(B[j]);
        }

        for (auto j : L[i])
        {
            if (!pos1.empty())
            {
                A[j] = *pos1.begin();
                pos1.erase(pos1.begin());
                continue;
            }

            if (!pos2.empty())
            {
                B[j] = *pos2.begin();
                pos2.erase(pos2.begin());
                sum[B[j]] += cnt[j];
            }
        }
    }

    int ans = INF;

    for (int i = 0; i < m; ++i)
        ans = min(ans, sum[i]);

    for (int i = 0; i < m; ++i)
        if (sum[i] == ans)
        {
            cout << ans << ' ' << i + 1 << endl;
            return 0;
        }

    return 0;
}

