#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
using namespace std;


int n, k, m;


int dst(pair <int, int> A, pair <int, int> B) {
//    if (A.second < B.first)
    return max(0LL, min(A.second, B.second) - max(A.first, B.first) + 1LL);
}

int sol_1(vector <int> & days) {
    vector <pair <int, int> > ans;
    ans.push_back(make_pair(days[0] - k + 1, days[0]));
    for (int i = 1; i < days.size(); i++) {
        if (days[i] > ans.back().second) {
            ans.push_back(make_pair(days[i], days[i] + k - 1));
        }
    }
    int answer = 0;
    for (auto elem : ans) {
        answer += dst(elem, make_pair(1LL, n));
    }
    return n - answer;
}

int sol_2(vector <int> & days) {
    vector <pair <int, int> > ans;
    ans.push_back(make_pair(days[0], days[0] + k - 1));
    for (int i = 1; i < days.size(); i++) {
        if (days[i] > ans.back().second) {
            ans.push_back(make_pair(days[i], days[i] + k - 1));
        }
    }
    int answer = 0;
    for (auto elem : ans) {
        answer += dst(elem, make_pair(1, n));
    }
    return n - answer;
}

signed main() {
    cin >> n >> k >> m;
    vector <int> day(m);
    for (int i = 0; i < m; i++) {
        cin >> day[i];
    }
    sort(day.begin(), day.end());
    vector <int> dp(m + 1);
    dp[0] = 0;
    dp[1] = max(n - (day.back() + k), 0);
    for (int i = 2; i <= m; ++i)
    {
        int ind = upper_bound(day.begin(), day.end(), day[m - i] + k - 1) - day.begin();

        if (ind == m)
        {
            dp[i] = max((n - (day[m - i] + k - 1)), 0);
        }
        else
        {
            dp[i] = dp[m - ind] + day[ind] - day[m - i] - k;
        }
    }
    int pt = 0;
    int ans = dp[m] + day[0] - 1;
    while (pt < m && day[pt] <= k)
    {
        ans = max(ans, day[pt + 1] - day[pt] - 1 + dp[m - pt - 1]);
        pt++;
    }
    cout << ans;
}
