import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class G {
    String fileName = "<name>";
    
    public static int dist(int x, int y) {
		return Math.max(0, y - x - 1);
	}

    public void solve() throws IOException {
        // write your code here
    	int n = nextInt();
    	int k = nextInt();
    	int m = nextInt();
    	int[] x = new int[m];
    	for (int i = 0; i < x.length; i++) {
			x[i] = nextInt() - 1;
		}
    	Arrays.sort(x);
    	int[] dp = new int[m];
    	for (int i = m - 1; i >= 0; i--) {
			if (x[i] + k - 1>= n) {
				dp[i] = 0;
			} else {
				int l = i;
				int r = m;
				while (l + 1 < r) {
					int med = (l + r) / 2;
					if (x[med] > x[i] + k - 1) {
						r = med;
					} else {
						l = med;
					}
					
				}
				
				if (r == m) {
					dp[i] = n - 1 - x[i] - k + 1;
				} else {
					dp[i] = dist(x[i] + k - 1, x[r]) + dp[r];
					
				}
			
			}
    	}
    	
    	int ans = dp[0] + x[0];
    	
    	if (x[m - 1] <= k - 1) {
			ans = Math.max(ans, Math.max(0, n - 1 - x[m - 1] ));
		}
    	for (int i = 0; i < m - 1 && x[i] <= k - 1; i++) {
			ans = Math.max(ans, dp[i + 1] + Math.max(x[i + 1] - x[i] - 1, 0));
		}
    	System.out.println(ans);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new G().run();
    }

}
