#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;

int main()
{
	int n, m;
	cin >> n >> m;
	vector<vector<int> > a(n, vector<int>(m));
	for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            char c;
            cin >> c;
            a[i][j] = c - 'a';
        }
	}
	vector<vector<vector<int> > >  left(26, vector<vector<int> >(n, vector<int>(m, 1e7))), right(26, vector<vector<int> > (n, vector<int>(m, 1e7))), up(26, vector<vector<int> > (n, vector<int>(m, 1e7))), down(26, vector<vector<int> >(n, vector<int>(m, 1e7)));
	for(int i = 0; i < 26; i++)
        for(int j = 0; j < n; j++)
            for(int k = 0; k < m; k++)
                left[i][j][k] = right[i][j][k] = up[i][j][k] = down[i][j][k] = 1e7;
	for(int i = 0; i < n; i++){
        for(int c = 0; c < 26; c++){
            for(int j = 1; j < m; j++){
                left[c][i][j] = (a[i][j - 1] == c) ? 1 : min(left[c][i][j], left[c][i][j - 1] + 1);
            }
        }
	}
	for(int i = 0; i < n; i++){
        for(int c = 0; c < 26; c++){
            for(int j = m - 2; j >= 0; j--){
                right[c][i][j] = (a[i][j + 1] == c) ? 1 : min(right[c][i][j], right[c][i][j + 1] + 1);
            }
        }
	}
    for(int j = 0; j < m; j++){
        for(int c = 0; c < 26; c++){
            for(int i = 1; i < n; i++){
                up[c][i][j] = (a[i - 1][j] == c) ? 1 : min(up[c][i][j], up[c][i - 1][j] + 1);
            }
        }
	}
    for(int j = 0; j < m; j++){
        for(int c = 0; c < 26; c++){
            for(int i = n - 2; i >= 0; i--){
                down[c][i][j] = (a[i + 1][j] == c) ? 1 : min(down[c][i][j], down[c][i + 1][j] + 1);
            }
        }
	}
	int q;
	cin >> q;
	for(int i = 0; i < q; i++){
        int x, y;
        scanf("%d%d", &x, &y);
        x--, y--;
        int x1, y1, x2, y2, ccx, ccy;
        int mindist = 1e6;
        for(int cx = 0; cx < 26; cx++){
            for(int cy = 0; cy < 26; cy++){
                if(cx == cy) continue;
                if (left[cx][x][y] + up[cy][x][y] < mindist) {
                    mindist = left[cx][x][y] + up[cy][x][y];
                    y1 = y - left[cx][x][y];
                    x1 = x;
                    y2 = y;
                    x2 = x - up[cy][x][y];
                }
                if(right[cx][x][y] + up[cy][x][y] < mindist){
                    mindist = right[cx][x][y] + up[cy][x][y];
                    y1 = y + right[cx][x][y];
                    x1 = x;
                    y2 = y;
                    x2 = x - up[cy][x][y];
                }
                if(right[cx][x][y] + down[cy][x][y] < mindist){
                    mindist = right[cx][x][y] + down[cy][x][y];
                    y1 = y + right[cx][x][y];
                    x1 = x;
                    y2 = y;
                    x2 = x + down[cy][x][y];
                }
                if(left[cx][x][y] + down[cy][x][y] < mindist){
                    mindist = left[cx][x][y] + down[cy][x][y];
                    y1 = y - left[cx][x][y];
                    x1 = x;
                    y2 = y;
                    x2 = x + down[cy][x][y];
                }
            }
        }
        if(mindist < 1e6){
            cout << x1 + 1 << ' ' << y1 + 1 << ' ' << x2 + 1 << ' ' << y2 + 1 << '\n';
        }
        else{
            cout << "-1\n";
        }
	}
}
