#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define mp make_pair

#ifndef LOCAL
#define cerr if(0)cerr
#endif // LOCAL

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = int(1e9);
const ll INFll = ll(1e18);

ll st[200001];

int main() {
    ios_base::sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, m, k;
    cin >> n >> m >> k;
    vector<pair<pair<ll, int>, int> > all;
    all.reserve(2 * k);
    for (int i = 0; i < k; i++) {
        int a, b;
        cin >> a >> b;
        all.pb({{b, 0}, i});
        all.pb({{a, 1}, i});
    }
    all.pb({{1, 1}, -1});
    all.pb({{n, 0}, -1});
    sort(all.begin(), all.end());
    set<int> fr;    // free seats
    vector<int > pos(k+1, -1); // where guy stands now
    vector<ll > frst(m, -1); // time when guy came here
    int fra = m;

    for(int i = 0; i < m; i++)
        fr.insert(i);

    for (int i = 0; i < all.size(); i++) {
//            cerr << all[i].F.F << " " << all[i].F.S << " ";
        if (all[i].F.S) {
            if(fra == 0 && fr.size() == 0) continue;
            if(fra == 0) {
                int p = *fr.begin();
                fr.erase(p);
                frst[p] = all[i].F.F;
                pos[all[i].S] = p;
            } else {
                fra--;
            }
        }
        else {
            if(all[i].S != -1 && pos[all[i].S] != -1) {
                int p = pos[all[i].S];
                fr.insert(p);
                pos[all[i].S] = -1;
                st[p] += all[i].F.F - frst[p];
                frst[p] = -1;
            } else
                if (all[i].S != -1) fra++;
        }
    }

    pair<ll, int> ans = {2e18, -1};
    for (int i = 0; i < m; i++) {
        ans = min(ans, {st[i], i});
    }
    cout << ans.F << ' ' << ans.S + 1 << endl;

    return 0;
}
