#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <vector>
using namespace std;

const int S = 1000000 + 3;
int x, y;
char s[S];
int l[26][S], r[26][S], u[26][S], d[26][S];

inline int get_(int ii, int jj){
	return ii * y + jj;
}

inline bool ff(int re, int rw)
{
	if (re != -1 && rw != -1 && re != rw)
		return true;
	return false;
}

int main(){
	cin >> x >> y;
	int i, j, k;
	for (i = 0; i < x; i++){
		for (j = 0; j < y; j++){
			cin >> s[get_(i, j)];
			s[get_(i, j)] -= 'a';
			for (k = 0; k < 26; k++)
				l[k][get_(i, j)] = r[k][get_(i, j)] = d[k][get_(i, j)] = u[k][get_(i, j)] = -1;
		}
	}

	for (i = 0; i < x; i++){
		for (j = 0; j < y; j++){
			for (k = 0; k < 26; k++){
				if (j - 1 >= 0 && s[get_(i, j - 1)] == k)
					l[k][get_(i, j)] = 1;
				else if (j - 1 >= 0 && l[k][get_(i, j - 1)] != -1)
					l[k][get_(i, j)] = l[k][get_(i, j - 1)] + 1;

				if (i - 1 >= 0 && s[get_(i - 1, j)] == k)
					u[k][get_(i, j)] = 1;
				else if (i - 1 >= 0 && u[k][get_(i - 1, j)] != -1)
					u[k][get_(i, j)] = u[k][get_(i - 1, j)] + 1;
			}
		}
	}
	for (i = x - 1; i >= 0; i--){
		for (j = y - 1; j >= 0; j--){
			for (k = 0; k < 26; k++){
				if (j + 1 < y && s[get_(i, j + 1)] == k)
					r[k][get_(i, j)] = 1;
				else if (j + 1 < y && r[k][get_(i, j + 1)] != -1)
					r[k][get_(i, j)] = r[k][get_(i, j + 1)] + 1;

				if (i + 1 < x && s[get_(i + 1, j)] == k)
					d[k][get_(i, j)] = 1;
				else if (i + 1 < x && d[k][get_(i + 1, j)] != -1)
					d[k][get_(i, j)] = d[k][get_(i + 1, j)] + 1;
			}
		}
	}
	int q;
	cin >> q;
	int a, b;
	int w = 0, aa1 = 10000000, aa2 = 10000000, a1 = -1, a2 = -1, b1 = -1, b2 = -1, bb1 = 10000000, bb2 = 10000000;
	int ia11 = -1, ia12 = -1, ia21 = -1, ia22 = -1, ib11 = -1, ib12 = -1, ib21 = -1, ib22 = -1;
	bool f;
	int ar1, ar2, arr;
	int as = 10000000, ina1, ina2, inb1, inb2, t;
	for (t = 0; t < q; t++){
		cin >> a >> b;
		--a;
		--b;
		w = get_(a, b), aa1 = 10000000, aa2 = 10000000, a1 = -1, a2 = -1, b1 = -1, b2 = -1, bb1 = 10000000, bb2 = 10000000;
		ia11 = -1, ia12 = -1, ia21 = -1, ia22 = -1, ib11 = -1, ib12 = -1, ib21 = -1, ib22 = -1;
		for (i = 0; i < 26; i++)
		{
			f = false;
			ar1 = l[i][w], ar2 = r[i][w];
			if (ar1 == -1 && ar2 == -1)
				continue;
			else if (ar1 == -1)
			{
				arr = ar2;
				f = false;
			}
			else if (ar2 == -1)
			{
				arr = ar1;
				f = true;
			}
			else
			{
				if (ar1 < ar2)
				{
					arr = ar1;
					f = true;
				}
				else
				{
					arr = ar2;
					f = false;
				}
			}
			if (aa1 > arr)
			{
				aa2 = aa1;
				a2 = a1;
				ia21 = ia11;
				ia22 = ia12;
				aa1 = arr;
				a1 = i;
				if (f)
				{
					ia11 = a;
					ia12 = b - arr;
				}
				else
				{
					ia11 = a;
					ia12 = b + arr;
				}
			}
			else if (aa2 > arr)
			{
				aa2 = arr;
				a2 = i;
				if (f)
				{
					ia21 = a;
					ia22 = b - arr;
				}
				else
				{
					ia21 = a;
					ia22 = b + arr;
				}
			}
		}
		for (i = 0; i < 26; i++)
		{
			f = false;
			ar1 = u[i][w], ar2 = d[i][w];
			if (ar1 == -1 && ar2 == -1)
				continue;
			else if (ar1 == -1)
			{
				arr = ar2;
				f = false;
			}
			else if (ar2 == -1)
			{
				arr = ar1;
				f = true;
			}
			else
			{
				if (ar1 < ar2)
				{
					arr = ar1;
					f = true;
				}
				else
				{
					arr = ar2;
					f = false;
				}
			}
			if (bb1 > arr)
			{
				bb2 = bb1;
				b2 = b1;
				ib21 = ib11;
				ib22 = ib12;
				bb1 = arr;
				b1 = i;
				if (f)
				{
					ib11 = a - arr;
					ib12 = b;
				}
				else
				{
					ib11 = a + arr;
					ib12 = b;
				}
			}
			else if (bb2 > arr)
			{
				bb2 = arr;
				b2 = i;
				if (f)
				{
					ib21 = a - arr;
					ib22 = b;
				}
				else
				{
					ib21 = a + arr;
					ib22 = b;
				}
			}
		}
		as = 10000000;
		if (ff(a1, b1))
		{
			if (as > aa1 + bb1)
			{
				as = aa1 + bb1;
				ina1 = ia11;
				ina2 = ia12;
				inb1 = ib11;
				inb2 = ib12;
			}
		}
		if (ff(a2, b1))
		{
			if (as > aa2 + bb1)
			{
				as = aa2 + bb1;
				ina1 = ia21;
				ina2 = ia22;
				inb1 = ib11;
				inb2 = ib12;
			}
		}
		if (ff(a1, b2))
		{
			if (as > aa1 + bb2)
			{
				as = aa1 + bb2;
				ina1 = ia11;
				ina2 = ia12;
				inb1 = ib21;
				inb2 = ib22;
			}
		}
		if (ff(a2, b2))
		{
			if (as > aa2 + bb2)
			{
				as = aa2 + bb2;
				ina1 = ia21;
				ina2 = ia22;
				inb1 = ib21;
				inb2 = ib22;
			}
		}
		if (as == 10000000)
			printf("%d\n", -1);
		else
		{
			printf("%d %d %d %d\n", ina1 + 1, ina2 + 1, inb1 + 1, inb2 + 1);
		}
	}
}
