#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <stdio.h>
#include <list>
#include <math.h>
#include <time.h>
#include <queue>
#pragma warning(disable: 4996)
typedef long long ll;
typedef long double ld;
using namespace std;

const ll SZ = 4e5 + 10;
const ll INF = 1e9;

//bool l[SZ][SZ], e[SZ][SZ];
//ll xold[SZ][SZ], xnew[SZ][SZ];
vector<pair<pair<int, int>, int>> ord;
vector<pair<int, int>> t[SZ];
int att[SZ], tot[SZ];
priority_queue<int> fp;
priority_queue<pair<int, int>> leave;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
#endif
	ios::sync_with_stdio(false);

	/*ll n, k, m;
	cin >> n >> k >> m;
	while (m--) {
		ll x;
		cin >> x;
		d.push_back(x);
		e.push_back(x);
	}
	sort(d.rbegin(), d.rend());
	sort(e.rbegin(), e.rend());
	
	ll r = 0;
	while (d.size()) {
		r++;
		ll x = d.back();
		while (d.size() && d.back() <= x + k)
			d.pop_back();
	}

	cout << n - r * k;*/

	/*ll n, m;
	cin >> n >> m;
	for (ll i = 0; i < n; i++) {
		ll x;
		cin >> x;
		while (x--) {
			ll d;
			cin >> d;
			d--;
			l[i][d] = true;
		}
	}
	for (ll i = 0; i < n; i++)
		for (ll j = 0; j < n; j++) {
			bool mt = false;
			for (ll k = 0; k < m; k++)
				if (l[i][k] && l[j][k])
					mt = true;
			if (mt)
				e[i][j] = true;
		}

	for (ll i = 0; i < n; i++)
		for (ll j = 0; j < n; j++)
			if (i == j)
				xold[i][j] = 0;
			else if (e[i][j])
				xold[i][j] = 1;
			else
				xold[i][j] = INF;

	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < n; j++)
			for (ll k = 0; k < n; k++)
				xnew[j][k] = min(xold[j][k], xold[j][i] + xold[i][k]);
		for (ll j = 0; j < n; j++)
			for (ll k = 0; k < n; k++)
				xold[j][k] = xnew[j][k];
	}

	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < n; j++)
			cout << (xold[i][j] == INF ? -1 : xold[i][j]) << " ";
		cout << "\n";
	}*/
	int n, m, k;
	cin >> n >> m >> k;
	for (int i = 0; i < k; i++) {
		int a, b;
		scanf("%d%d", &a, &b);
		ord.push_back({ { a, i }, b });
	}
	sort(ord.rbegin(), ord.rend());
	
	for (int i = 0; i < 2 * m; i++)
		fp.push(-i);
	
	while (ord.size()) {
		int tt = ord.back().first.first;
		while (leave.size() && (-leave.top().first) <= tt) {
			t[att[-leave.top().second]].back().second = -leave.top().first;
			fp.push(-att[-leave.top().second]);
			leave.pop();
		}
		if (!fp.size()) {
			ord.pop_back();
			continue;
		}
		att[ord.back().first.second] = -fp.top();
		fp.pop();
		t[att[ord.back().first.second]].push_back({ ord.back().first.first, 0 });
		leave.push({ -ord.back().second, -ord.back().first.second });
		ord.pop_back();
	}
	while (leave.size()) {
		t[att[-leave.top().second]].back().second = -leave.top().first;
		fp.push(-att[-leave.top().second]);
		leave.pop();
	}

	int bst = INF, pos = 0;

	for (int i = m - 1; i < 2 * m - 1; i++) {
		int s = 0;
		for (auto j : t[i])
			s += j.second - j.first;
		if (s < bst) {
			bst = s;
			pos = i - m + 2;
		}
	}

	cout << bst << " " << pos;

	return 0;
}