#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <stdio.h>
#include <list>
#include <math.h>
#include <time.h>
#include <queue>
#pragma warning(disable: 4996)
typedef long long ll;
typedef long double ld;
using namespace std;

const ll SZ = 4e5 + 10;
const ll INF = 1e9;

//bool l[SZ][SZ], e[SZ][SZ];
//ll xold[SZ][SZ], xnew[SZ][SZ];
int d[SZ], e[SZ];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
#endif
	ios::sync_with_stdio(false);

	/*ll n, k, m;
	cin >> n >> k >> m;
	while (m--) {
		ll x;
		cin >> x;
		d.push_back(x);
		e.push_back(x);
	}
	sort(d.rbegin(), d.rend());
	sort(e.rbegin(), e.rend());
	
	ll r = 0;
	while (d.size()) {
		r++;
		ll x = d.back();
		while (d.size() && d.back() <= x + k)
			d.pop_back();
	}

	cout << n - r * k;*/

	/*ll n, m;
	cin >> n >> m;
	for (ll i = 0; i < n; i++) {
		ll x;
		cin >> x;
		while (x--) {
			ll d;
			cin >> d;
			d--;
			l[i][d] = true;
		}
	}
	for (ll i = 0; i < n; i++)
		for (ll j = 0; j < n; j++) {
			bool mt = false;
			for (ll k = 0; k < m; k++)
				if (l[i][k] && l[j][k])
					mt = true;
			if (mt)
				e[i][j] = true;
		}

	for (ll i = 0; i < n; i++)
		for (ll j = 0; j < n; j++)
			if (i == j)
				xold[i][j] = 0;
			else if (e[i][j])
				xold[i][j] = 1;
			else
				xold[i][j] = INF;

	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < n; j++)
			for (ll k = 0; k < n; k++)
				xnew[j][k] = min(xold[j][k], xold[j][i] + xold[i][k]);
		for (ll j = 0; j < n; j++)
			for (ll k = 0; k < n; k++)
				xold[j][k] = xnew[j][k];
	}

	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < n; j++)
			cout << (xold[i][j] == INF ? -1 : xold[i][j]) << " ";
		cout << "\n";
	}*/

	int n, k, m;
	cin >> n >> k >> m;
	for (int i = 0; i < m; i++)
		cin >> d[i];

	sort(d, d + m);
	int ans = INF;
	for (int i = m - 1; i >= 0; i--) {
		auto f = lower_bound(d, d + m, d[i] + k);
		if (f - d == m)
			e[i] = min(n, d[i] + k - 1) - d[i] + 1;
		else
			e[i] = e[f - d] + k;
		int add = INF;
		if (!i)
			add = 0;
		else if (d[i - 1] - d[0] < k)
			add = d[i - 1] - max(1, d[i - 1] - k + 1) + 1;

		ans = min(ans, e[i] + add);
	}

	cout << n - ans;

	return 0;
}