#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <algorithm>
#include <stdio.h>
#include <list>
#include <math.h>
#include <time.h>
#include <queue>
#pragma warning(disable: 4996)
typedef long long ll;
typedef long double ld;
using namespace std;

const ll SZ = 5e5 + 10;
const ll INF = 1e9;
const ll MOD = 1e18;

//bool l[SZ][SZ], e[SZ][SZ];
//ll xold[SZ][SZ], xnew[SZ][SZ];
string st[SZ];

int main() {
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
#endif
	ios::sync_with_stdio(false);

	/*ll n, m;
	cin >> n >> m;
	for (ll i = 0; i < n; i++) {
	ll x;
	cin >> x;
	while (x--) {
	ll d;
	cin >> d;
	d--;
	l[i][d] = true;
	}
	}
	for (ll i = 0; i < n; i++)
	for (ll j = 0; j < n; j++) {
	bool mt = false;
	for (ll k = 0; k < m; k++)
	if (l[i][k] && l[j][k])
	mt = true;
	if (mt)
	e[i][j] = true;
	}

	for (ll i = 0; i < n; i++)
	for (ll j = 0; j < n; j++)
	if (i == j)
	xold[i][j] = 0;
	else if (e[i][j])
	xold[i][j] = 1;
	else
	xold[i][j] = INF;

	for (ll i = 0; i < n; i++) {
	for (ll j = 0; j < n; j++)
	for (ll k = 0; k < n; k++)
	xnew[j][k] = min(xold[j][k], xold[j][i] + xold[i][k]);
	for (ll j = 0; j < n; j++)
	for (ll k = 0; k < n; k++)
	xold[j][k] = xnew[j][k];
	}

	for (ll i = 0; i < n; i++) {
	for (ll j = 0; j < n; j++)
	cout << (xold[i][j] == INF ? -1 : xold[i][j]) << " ";
	cout << "\n";
	}*/

	ll x, m;
	cin >> x >> m;
	cout << "? 1" << endl;
	ll res;
	cin >> res;
	if (res == x) {
		cout << "! 1" << endl;
		return 0;
	}
	ll l = x - res - m - 1 + 3 * MOD;
	ll r = x - res + 1 + 3 * MOD;
	ll it = 9;
	while (l <= r && it--) {
		ll mm = (l + r) / 2;
		cout << "? " << ((mm - 1) % MOD) + 1 << endl;
		cin >> res;
		if (res == x) {
			cout << "! " << ((mm - 1) % MOD) + 1 << endl;
			return 0;
		}
		if ((res < x && abs(res - x) < 1000) || (res > x && abs(res - x) > 1000))
			l = mm + 1; 
		else
			r = mm - 1;
	}
	cout << "! -1" << endl;
	return 0;
		
	/*int n, m;
	cin >> n >> m;
	vector<vector<char>> st(n, vector<char>(m));
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			cin >> st[i][j];

	vector<vector<vector<int>>> q(n, vector<vector<int>>(m));

	int qq;
	cin >> qq;
	for (int i = 0; i < qq; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		q[a][b].push_back(i);
	}

	vector<vector<vector<int>>> hors(26, vector<vector<int>>(n));
	vector<vector<vector<int>>> vers(26, vector<vector<int>>(m));
	vector<vector<int>> horp(26, vector<int>(n, -INF));
	vector<vector<int>> verp(26, vector<int>(m, -INF));

	vector<vector<int>> resver(26, vector<int>(m));
	vector<vector<int>> reshor(26, vector<int>(n));

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			resver[st[i][j] - 'a'][j]++;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			reshor[st[i][j] - 'a'][i]++;
	
	for (int i = 0; i < 26; i++)
		for (int j = 0; j < m; j++)
			vers[i][j].reserve(resver[i][j]);
	for (int i = 0; i < 26; i++)
		for (int j = 0; j < n; j++)
			hors[i][j].reserve(reshor[i][j]);

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			hors[st[i][j] - 'a'][i].push_back(j);
	for (int j = 0; j < m; j++)
		for (int i = 0; i < n; i++)
			vers[st[i][j] - 'a'][j].push_back(i);

	for (int i = 0; i < 26; i++)
		for (int j = 0; j < n; j++)
			reverse(hors[i][j].begin(), hors[i][j].end());
	for (int i = 0; i < 26; i++)
		for (int j = 0; j < m; j++)
			reverse(vers[i][j].begin(), vers[i][j].end());

	vector<pair<pair<int, int>, pair<int, int>>> ans(qq);

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++)
			vers[st[i][j] - 'a'][j].pop_back();
		for (int j = 0; j < m; j++) {
		hors[st[i][j] - 'a'][i].pop_back();
		int mn = INF, cx, cy, dx, dy;
		cx = cy = dx = dy = -1;
		if (i && mn > 2) { // up
			for (int k = 0; k < 26; k++)
				if (k != st[i - 1][j] - 'a') {
				if (hors[k][i].size())
					if (abs(hors[k][i].back() - j) + 1 < mn) {
					mn = abs(hors[k][i].back() - j) + 1;
					cx = i - 1;
					cy = j;
					dx = i;
					dy = hors[k][i].back();
					}
				int e = horp[k][i];
				if (abs(e - j) + 1 < mn) {
					mn = abs(e - j) + 1;
					cx = i - 1;
					cy = j;
					dx = i;
					dy = e;
				}
				}
		}

		if (i != n - 1 && mn > 2) { // down
			for (int k = 0; k < 26; k++)
				if (k != st[i + 1][j] - 'a') {
				if (hors[k][i].size())
					if (abs(hors[k][i].back() - j) + 1 < mn) {
					mn = abs(hors[k][i].back() - j) + 1;
					cx = i + 1;
					cy = j;
					dx = i;
					dy = hors[k][i].back();
					}
				int e = horp[k][i];
				if (abs(e - j) + 1 < mn) {
					mn = abs(e - j) + 1;
					cx = i + 1;
					cy = j;
					dx = i;
					dy = e;
				}
				}
		}

		if (j && mn > 2) { // left
			for (int k = 0; k < 26; k++)
				if (k != st[i][j - 1] - 'a') {
				if (vers[k][j].size())
					if (abs(vers[k][j].back() - i) + 1 < mn) {
					mn = abs(vers[k][j].back() - i) + 1;
					cx = i;
					cy = j - 1;
					dx = vers[k][j].back();
					dy = j;
					}
				int e = verp[k][j];
				if (abs(e - i) + 1 < mn) {
					mn = abs(e - i) + 1;
					cx = i;
					cy = j - 1;
					dx = verp[k][j];
					dy = j;
				}
				}
		}

		if (j != m - 1 && mn > 2) { // right
			for (int k = 0; k < 26; k++)
				if (k != st[i][j + 1] - 'a') {
				if (vers[k][j].size())
					if (abs(vers[k][j].back() - i) + 1 < mn) {
					mn = abs(vers[k][j].back() - i) + 1;
					cx = i;
					cy = j + 1;
					dx = vers[k][j].back();
					dy = j;
					}
				int e = verp[k][j];
				if (abs(e - i) + 1 < mn) {
					mn = abs(e - i) + 1;
					cx = i;
					cy = j + 1;
					dx = verp[k][j];
					dy = j;
				}
				}
		}

		for (int k : q[i][j])
			ans[k] = make_pair(make_pair(cx, cy), make_pair(dx, dy));
		horp[st[i][j] - 'a'][i] = j;

		}
		for (int j = 0; j < m; j++)
			verp[st[i][j] - 'a'][j] = i;
	}

	for (auto i : ans) {
		if (i.first.first == -1)
			printf("-1\n");
		else
			printf("%d %d %d %d\n", i.first.first + 1, i.first.second + 1, i.second.first + 1, i.second.second + 1);
	}*/

	return 0;
}