#include <cstdio>
#include <iostream>
#include <algorithm>

using namespace std;

const double EPS = 1e-9;
typedef long long ll;

long long find_divs(ll n) {
	long long res = 0;
	ll div;
	for (div = 1; div * div < n; ++div) {
		if (n % div == 0)
		{
			res += 2;
		}
	}
	if (div * div == n)
	{
		++res;
	}
	return res;
}

int main() {
#ifdef MINE
	freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(nullptr);

	ll x;
	cin >> x;
	for (ll y = x; y <= 1.01 * x + EPS; ++y)	{
		if (find_divs(y) >= 100)
		{
			cout << y;
			return 0;
		}
	}
	cout << -1;
	
	return 0;
}