#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

const double EPS = 1e-9;
typedef long long ll;
const int sz = 5e2;
const int INF = (int)1e9;
const ll eps = (ll) 1e10;
const ll border = (ll) 1e12;

ll get(ll arg) {
	ll res = 0;
	ll i = 1;
	for (i = 1; i * i < arg; i++) {
		if (arg % i == 0) {
			res += 2;
		}
		if (res >= 100) {
			break;
		}
	}
	if (arg == i * i) {
		res++;
	}
	return res;
}

int main() {
#ifdef MINE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ll n;
	cin >> n;
	ll m = n + (n / 100);
	ll counter = 0;
	if (n >= border) {
		m = n + 2 * eps;
		cout << (m / eps) * eps;
		return 0;
	}
	for (ll i = n; i <= m; i+= 10) {
		if (get(i) >= 100) {
			cout << i;
			return 0;
		}
	}
	cout << -1;
	return 0;
}