#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;


int bs(vector<int>& d, int s, int dist) {
    int left = -1, right = s - 1, ds = d[s] - dist, middle;
    while (left < right) {
        if (right == 0)
          middle = 0;
        else
          middle = (left + right) / 2 + 1;
        if (d[middle] <= ds)
            left = middle;
        else
            right = middle - 1;
    }
    return left;
}

int main() {
    int n, k, m;
    cin >> n >> k >> m;
    vector<int> p1(m, 0), p2(m, 0), d(m);
    for (int i = 0; i < m; i++)
        cin >> d[i];
    sort(d.begin(), d.end());
    p1[0] = min(k, d[0]);
    p2[0] = min(k, n - d[0] + 1);

    for (int i = 1; i < m; i++) {
        int dk = bs(d, i, k);
        int d2k = bs(d, i, 2 * k - 1);
        p1[i] = min(k, d[i]);
        if (d2k >= 0)
            p1[i] += min(p1[dk], p2[d2k]);
        else if (dk >= 0)
            p1[i] += p1[dk];

        p2[i] = min(k, n - d[i] + 1);
        if (dk >= 0)
            p2[i] += min(p1[i - 1], p2[dk]);
        else
            p2[i] += p1[i - 1];
    }
    cout << n - min(p2[m - 1], p1[m - 1]) << endl;
    return 0;
}
