#include <iostream>
#include <cmath>

using namespace std;

long long fact(long long x) {
    long long val = 1, cnt = 0, d = 2;
    while (x > 1) {
        if (d * d > x) d = x;
        //if (d * d * d > x) d = int(sqrtl(x));
        if (x % d == 0) {
            cnt = 0;
            while (x % d == 0) {
                cnt++;
                x /= d;
            }
            val *= (cnt + 1);
        }
        d++;
    }
    return val;
}

int main() {
  long long x;
  cin >> x;
  if (x > 9072000) {
    if (x % 90720 == 0) {
        cout << x << endl;
    } else {
        cout << ((x + 90720) / 90720) * 90720 << endl;
    }
    return 0;
  }
  for (long long y = x; y <= (x + x / 100); y++) {
    if (fact(y) >= 100) {
        cout << y << endl;
        return 0;
    }
  }
  cout << -1 << endl;
  return 0;
}
