#define _CRT_SECURE_NO_WARNINGS
//#pragma comment(linker, "/STACK:256000000")
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
const int INF = (int)1e9 + 7;

int solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	solve();
	return 0;
}

bool ok(int x) {
	int ans = 0;
	for (int i = 1; i * i <= x; i++) {
		if (x % i == 0) ans += 2;
		if (i * i == x) ans--;
	}
	return (ans >= 100);
}

int solve() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	long long x;
	cin >> x;

	if (x >= 4536000) cout << (45360 - (x % 45360) + x), exit(0);
	else 
		for (int i = x; i <= 1.01 * x; i++)
			if (ok(i)) cout << i, exit(0);
	cout << -1;
	return 0;
}


