#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#define SZ(v) (int)v.size()
#define p(x,y) pair<x,y>
#define X first
#define Y second
using namespace std;
const int N = 500005;
const long long INF = (1LL << 61);
typedef long long ll;
ll n, m, q, x, y;
string s[N];
vector<vector<p(int, int)> > up[N], le[N], ri[N], dw[N];
int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	for (int i = 0; i < n; i++){
		cin >> s[i];
		for (int j = 0; j < m; j++){
			up[i].push_back(vector<p(int, int)>());
			le[i].push_back(vector<p(int, int)>());
			ri[i].push_back(vector<p(int, int)>());
			dw[i].push_back(vector<p(int, int)>());
		}
	}
	for (int i = 0; i < n; i++){
		for (int j = 0; j < m; j++){
			if (i){
				if (s[i][j] == s[i - 1][j] && 0){up[i][j] = up[i - 1][j];}
				else{
					up[i][j].push_back({ i - 1, j });
					for (int ss = 0; ss < SZ(up[i - 1][j]);ss++)if (1 || s[i][j] != s[up[i-1][j][ss].X][up[i-1][j][ss].Y]){
						bool ok = 1;

						for (int us = 0; us < SZ(up[i][j]); us++)
							ok &= bool(s[up[i][j][us].X][up[i][j][us].Y] != s[up[i - 1][j][ss].X][up[i - 1][j][ss].Y]);

						if (ok && SZ(up[i][j]) < 2)up[i][j].push_back(up[i - 1][j][ss]);
						}
					}
			}
			if (j){

				if (s[i][j] == s[i][j - 1] && 0){ le[i][j] = le[i][j - 1]; }
				else{
					le[i][j].push_back({ i, j-1 });
					for (int ss = 0; ss < SZ(le[i][j - 1]); ss++)if (1 || s[i][j] != s[le[i][j - 1][ss].X][le[i][j - 1][ss].Y]){
						bool ok = 1;

						for (int us = 0; us < SZ(le[i][j]); us++)
							ok &= bool(s[le[i][j][us].X][le[i][j][us].Y] != s[le[i][j - 1][ss].X][le[i][j - 1][ss].Y]);

						if (ok && SZ(le[i][j]) < 2)le[i][j].push_back(le[i][j - 1][ss]);
					}
				}

			}
		}
	}

	for (int i = n - 1; i >= 0; i--){
		for (int j = m - 1; j >= 0; j--){
			if (i != n-1){
				if (s[i][j] == s[i + 1][j] && 0){ dw[i][j] = dw[i + 1][j]; }
				else{
					dw[i][j].push_back({ i + 1, j });
					for (int ss = 0; ss < SZ(dw[i + 1][j]); ss++)if (1 || s[i][j] != s[dw[i + 1][j][ss].X][dw[i + 1][j][ss].Y]){
						bool ok = 1;

						for (int us = 0; us < SZ(dw[i][j]); us++)
							ok &= bool(s[dw[i][j][us].X][dw[i][j][us].Y] != s[dw[i + 1][j][ss].X][dw[i + 1][j][ss].Y]);

						if (ok && SZ(dw[i][j]) < 2)dw[i][j].push_back(dw[i + 1][j][ss]);
					}
				}
			}
			if (j != m-1){

				if (s[i][j] == s[i][j + 1] && 0){ ri[i][j] = ri[i][j + 1]; }
				else{
					ri[i][j].push_back({ i, j + 1 });
					for (int ss = 0; ss < SZ(ri[i][j + 1]); ss++)if (1 || s[i][j] != s[ri[i][j + 1][ss].X][ri[i][j + 1][ss].Y]){
						bool ok = 1;

						for (int us = 0; us < SZ(ri[i][j]); us++)
							ok &= bool(s[ri[i][j][us].X][ri[i][j][us].Y] != s[ri[i][j + 1][ss].X][ri[i][j + 1][ss].Y]);

						if (ok && SZ(ri[i][j]) < 2)ri[i][j].push_back(ri[i][j + 1][ss]);
					}
				}

			}
		}
	}
	cin >> q;
	while (q--){
		cin >> x >> y;
		x--, y--;
		int ai = -1, aj = -1, bi = -1, bj = -1;
		for (int i = 0; i < SZ(up[x][y]); i++){
			for (int j = 0; j < SZ(le[x][y]); j++){
				int i1 = up[x][y][i].X;
				int j1 = up[x][y][i].Y;
				int i2 = le[x][y][j].X;
				int j2 = le[x][y][j].Y;
				if (s[i1][j1] != s[i2][j2]){
					if (ai == -1 || abs(i1 - i2) + abs(j1 - j2) < abs(ai - bi) + abs(aj - bj))ai = i1, aj = j1, bi = i2, bj = j2;
				}
			}

			for (int j = 0; j < SZ(ri[x][y]); j++){
				int i1 = up[x][y][i].X;
				int j1 = up[x][y][i].Y;
				int i2 = ri[x][y][j].X;
				int j2 = ri[x][y][j].Y;
				if (s[i1][j1] != s[i2][j2]){
					if (ai == -1 || abs(i1 - i2) + abs(j1 - j2) < abs(ai - bi) + abs(aj - bj))ai = i1, aj = j1, bi = i2, bj = j2;
				}
			}
		}

		for (int i = 0; i < SZ(dw[x][y]); i++){
			for (int j = 0; j < SZ(le[x][y]); j++){
				int i1 = dw[x][y][i].X;
				int j1 = dw[x][y][i].Y;
				int i2 = le[x][y][j].X;
				int j2 = le[x][y][j].Y;
				if (s[i1][j1] != s[i2][j2]){
					if (ai == -1 || abs(i1 - i2) + abs(j1 - j2) < abs(ai - bi) + abs(aj - bj))
						ai = i1, aj = j1, bi = i2, bj = j2;
				}
			}

			for (int j = 0; j < SZ(ri[x][y]); j++){
				int i1 = dw[x][y][i].X;
				int j1 = dw[x][y][i].Y;
				int i2 = ri[x][y][j].X;
				int j2 = ri[x][y][j].Y;
				if (s[i1][j1] != s[i2][j2]){
					if (ai == -1 || abs(i1 - i2) + abs(j1 - j2) < abs(ai - bi) + abs(aj - bj))
						ai = i1, aj = j1, bi = i2, bj = j2;
				}
			}
		}

		if (ai == -1)cout << -1 << endl;
		else cout << ai+1 << " " << aj+1 << " " << bi+1 << " " << bj+1 << endl;
	}
}