#include <iostream>
#include <cstdlib>
#define ll long long

using namespace std;

const ll C = 7 + 1e9, X = 10007, Y = 10009, Z = 87277, G = 19, F = 17;

inline void oper(const ll& x, const ll& y, const ll& r, ll& z)
{
	z = (X * x + Y * y + Z) % r;
}

int main()
{
	ll h, w, n, *ax, *bx, *cx, *dx, i, k, *rowper, *rowoper, *columnper, *columnoper, **arr, j, *g, *f, sum;
	char *c;
	cin >> h >> w >> n;
 
	c = new char[n + 1];
	cin.getline(c, n + 1);
	cin.getline(c, n + 1);
	
	cin >> k;
	ax = new ll[n];
	for (i = 0; i < k; ++i)
		cin >> ax[i];
	for (i = k; i < n; ++i)
		oper(ax[i - 2], ax[i - 1], h, ax[i]);

	cin >> k;
	bx = new ll[n];
	for (i = 0; i < k; ++i)
		cin >> bx[i];
	for (i = k; i < n; ++i)
		oper(bx[i - 2], bx[i - 1], w, bx[i]);

	cin >> k;
	cx = new ll[n];
	for (i = 0; i < k; ++i)
		cin >> cx[i];
	for (i = k; i < n; ++i)
		oper(cx[i - 2], cx[i - 1], h, cx[i]);

	cin >> k;
	dx = new ll[n];
	for (i = 0; i < k; ++i)
		cin >> dx[i];
	for (i = k; i < n; ++i)
		oper(dx[i - 2], dx[i - 1], w, dx[i]);

	arr = new ll*[h];
	for (i = 0; i < h; ++i)
	{
		k = i * w;
		arr[i] = new ll[w];
		for (j = 0; j < w; ++j)
			arr[i][j] = k + j;
	}

	rowper = new ll[h];
	rowoper = new ll[h];
	for (i = 0; i < h; ++i)
	{
		rowper[i] = i;
		rowoper[i] = i;
	}

	columnper = new ll[w];
	columnoper = new ll[w];
	for (i = 0; i < w; ++i)
	{
		columnper[i] = i;
		columnoper[i] = i;
	}

	for (i = 0; i < n; ++i)
	{
		if (c[i] == 'c')
		{
			swap(columnper[bx[i]], columnper[dx[i]]);
			swap(columnoper[columnper[bx[i]]], columnoper[columnper[dx[i]]]);
		}
		else if (c[i] == 'r')
		{
			swap(rowper[ax[i]], rowper[cx[i]]);
			swap(rowoper[rowper[ax[i]]], rowoper[rowper[cx[i]]]);
		}
		else
		{
			swap(arr[rowoper[ax[i]]][columnoper[bx[i]]], arr[rowoper[cx[i]]][columnoper[dx[i]]]);
		}
	}

	g = new ll[w];
	*g = 1;
	for (i = 1; i < w; ++i)
		g[i] = (g[i - 1] * G) % C;
    
	f = new ll[h];
	*f = 1;
	for (i = 1; i < h; ++i)
		f[i] = (f[i - 1] * F) % C;

	sum = 0;
	for (i = 0; i < h; ++i)
	for (j = 0; j < w; ++j)
	{
		sum = (sum + arr[rowper[i]][columnper[j]] * f[i] * g[j]) % C;
	}
	cout << sum << endl;
	system("pause");
	return 0;
}

/*
3 5 3
crf
3 0 0 0
3 0 0 1
3 0 1 1
3 1 0 2
*/