#include <iostream>
#include <cmath>
#include <string>

using namespace std;

typedef long long ll;

int count(ll x) {
	int cnt = 0;

	for (ll i = 1; i <= sqrt(x); i++) {
		if ((x % i) == 0) {
			cnt++;
			if ((x / i) != i) {
				cnt++;
            }
        }
	}

	return cnt;
}

int main() {
	ll x;

	cin >> x;

	if (count(x) >= 100) {
		cout << x << "\n";
		return 0;
	}

	if (x >= 1e11) {
		cout << x / (ll)(1e9) + 1 << string(9, '0') << "\n";
		return 0;
    }

	for (ll y = x + 1; y <= x / 100 * 101; y++) {
		if (count(y) >= 100) {
			cout << y << '\n';
			return 0;
        }
    }
	
	cout << "-1\n";

	return 0;
}
