#include <stdio.h>
#include <vector>
#include <string>
#include <algorithm>
#include <iostream>

template <typename T>
T next_int() {
    T ans = 0, t = 1;
    char ch;
    do {ch = getchar(); } while(ch <= ' ') ;
    if(ch == '-') {
        t = -1;
        ch = getchar();
    }
    while(ch > ' ') {
        ans = ans * 10 + (ch - '0');
        ch = getchar();
    }
    return ans * t;
}

using namespace std;

string my_next_token() {
    char ch;
    string ans = "";
    do {ch = getchar(); } while(ch <= ' ') ;
    while(ch > ' ') {
        ans += ch;
        ch = getchar();
    }
    return ans;
}

const int MAXN = 5e3 + 7;
const int MAXM = 1e6 + 7;
const int inf = 2e9;
//const int INFINT = 1e9 + 227 + 1;
//const long long INF = 1e18 + 227 + 1;
const int MOD = (int)1e9 + 7;

#define all(a) (a).begin(), (a).end()
#define f first
#define ll long long
#define s second
#define pb push_back
#define mp make_pair

pair<int, int> e[MAXN][MAXN];

int z[2][MAXN];

long long a[MAXM];
int b[MAXM];
long long c[MAXM];
int d[MAXM];

long long semna[MAXN], devya[MAXN];

int main() {
//     freopen(".in", "r", stdin);
//    freopen(".out", "w", stdout);

    semna[0] = 1, devya[0] = 1;
    for (int i = 1; i < MAXN; i++) {
        semna[i] = semna[i - 1] * 17LL % MOD;
        devya[i] = devya[i - 1] * 19LL % MOD;
    }

    int h, w, m;
    cin >> h >> w >> m;

    string q = my_next_token();

    int k;
    cin >> k;
    for(int i = 0; i < k; i++) {
        a[i] = next_int<int>();
    }

    for(int i = k; i < m; i++) {
        a[i] = (a[i - 2] * 10007LL + a[i - 1] * 10009LL + 87277LL) % h;
    }

    cin >> k;
    for(int i = 0; i < k; i++) {
        b[i] = next_int<int>();
    }

    for(int i = k; i < m; k++) {
        b[i] = (10007LL * b[i - 2]  + 10009LL * b[i - 1]  + 87277LL) % w;
    }

    cin >> k;
    for(int i = 0; i < k; i++) {
        c[i] = next_int<int>();
    }

    for(int i = k; i < m; k++) {
        c[i] = (c[i - 2] * 10007LL + c[i - 1] * 10009LL + 87277LL) % h;
    }

    cin >> k;
    for(int i = 0; i < k; i++) {
        d[i] = next_int<int>();
    }

    for(int i = k; i < m; k++) {
        d[i] = (10007LL * d[i - 2]  + 10009LL * d[i - 1]  + 87277LL) % w;
    }

    for(int i = 0; i < h; i++)
        z[0][i] = i;
    for(int i = 0; i < w; i++)
        z[1][i] = i;

    for(int i = 0; i < h; i++)
        for(int j = 0; j < w; j++)
            e[i][j] = make_pair(i, j);

    for(int i = 0; i < m; i++) {
        char type = q[i];

        if(type == 'c') {
            int x = b[i];
            int y = d[i];

            swap(z[1][x], z[1][y]);
        }
        if(type == 'r') {
            int x = a[i];
            int y = c[i];

            swap(z[0][x], z[0][y]);
        }
        if(type == 'f') {
            int x = z[0][a[i]];
            int y = z[1][b[i]];
            int X = z[0][c[i]];
            int Y = z[1][d[i]];

            swap(e[x][y], e[X][Y]);
        }
//        for(int i = 0; i < h; i++) {
//            for(int j = 0; j < w; j++)
//                cout << qw[i][j] << " ";
//            puts("");
//        }
    }

    int ans = 0;
    for(int i = 0; i < h; i++) {
        for(int j = 0; j < w; j++) {
            int x = z[0][i];
            int y = z[1][j];

            int i2 = e[x][y].f, j2 = e[x][y].s;

//            qw[x][y] = i * w + j;

            ans = (((semna[i] * devya[j]) % MOD * (i2 * w + j2)) + ans) % MOD;
        }
    }

    cout << ans << "\n";

    return 0;
}
