#include <bits/stdc++.h>

using namespace std;

string s[500500];

inline int dist(pair<int, int> a, pair<int, int> b) {
    if (s[a.first][a.second] == s[b.first][b.second])
        return (int)2e9;
    if (a.first==b.first || a.second==b.second)
        return (int)2e9;
    return abs(a.first - b.first) + abs(a.second - b.second);
}

void solve(vector<pair<int,int>> &v) {
    int mn = (int)2e9;
    pair<int,int> x,y;
    for (auto i:v) for (auto j:v)
    if (dist(i,j)<mn) {
        mn = dist(i, j);
        x = i;
        y = j;
    }
    if (mn == (int)2e9) cout << "-1\n";
    else cout << x.first + 1 << " " << x.second + 1 << " " << y.first + 1 << " " << y.second + 1 << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++)
        cin >> s[i];
    vector<vector<int> > l(n+4),rg(n+4),u(n+4),d(n+4);
    for (auto &x:l) x.resize(m+4);
    for (auto &x:rg) x.resize(m+4);
    for (auto &x:u) x.resize(m+4);
    for (auto &x:d) x.resize(m+4);
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) {
            l[i][j] = -1;
            if (j > 0)
                l[i][j] = (s[i][j] == s[i][j - 1] ? l[i][j - 1] : j - 1);
        }
    for (int i = 0; i < n; i++)
        for (int j = m - 1; j >= 0; j--) {
            rg[i][j] = -1;
            if (j < m - 1)
                rg[i][j] = (s[i][j] == s[i][j + 1] ? rg[i][j + 1] : j + 1);
        }
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) {
            u[i][j] = -1;
            if (i > 0)
                u[i][j] = (s[i][j] == s[i - 1][j] ? u[i - 1][j] : i - 1);
        }
    for (int i = n - 1; i >= 0; i--)
        for (int j = 0; j < m; j++) {
            d[i][j] = -1;
            if (i < n - 1)
                d[i][j] = (s[i][j] == s[i + 1][j] ? d[i + 1][j] : i + 1);
        }

    int q;
    cin >> q;
    while (q--) {
        int r, c;
        cin >> r >> c;
        r--; c--;

        vector<pair<int,int>> g;

        if (r > 0) g.push_back(make_pair(r - 1, c));
        if (r > 0 && u[r - 1][c] != -1) g.push_back(make_pair(u[r - 1][c], c));

        if (r + 1 < n) g.push_back(make_pair(r + 1, c));
        if (r + 1 < n && d[r + 1][c] != -1) g.push_back(make_pair(d[r + 1][c], c));

        if (c > 0) g.push_back(make_pair(r, c - 1));
        if (c > 0 && l[r][c - 1] != -1) g.push_back(make_pair(r, l[r][c - 1]));

        if (c + 1 < m) g.push_back(make_pair(r, c + 1));
        if (c + 1 < m && rg[r][c + 1] != -1) g.push_back(make_pair(r, rg[r][c + 1]));

        solve(g);
    }

    return 0;
}
