#include <stdio.h>
#include <cctype>
#include <inttypes.h>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define ft first
#define sd second
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(x) begin((x)), end((x))
#define rall(x) (x).rbegin(), (x).rend()

/*<--------------------------------------------------------------------------->*/

const ll M = 1e18;

ll x, m, f;

ll ask(ll v)
{
    printf("? %lld\n", v + 1);
    fflush(stdout);
    ll ans;
    scanf("%lld", &ans);
    return ans - 1;
}

void solve()
{
    scanf("%lld%lld", &x, &m);
    --x;

    ll l = 0, r = m + 1, f = ask(0);

    while (l < r)
    {
        ll mid = (l + r) / 2;
        ll a = ask((f + x - mid + M) % M) ;
        if (a == x)
        {
            printf("! %lld", ((f + x - mid + M) % M) + 1);
            fflush(stdout);
            return;
        }
        if (a > x)
            r = mid;
        else
            l = mid;
        /*if ((x > a && x - a <= m) || (x < a && M - a + x <= m))
            r = mid - 1;
        else l = mid + 1;*/
    }

    printf("! %lld", ask((f + x - l + M) % M) == x ? ((f + x - l + M) % M) : -1);
    fflush(stdout);
}

/*<--------------------------------------------------------------------------->*/

//#define LOCAL

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
