#include <bits/stdc++.h>

#define ll long long

using namespace std;

struct event {

    int s, t, p, d;

    event (int _s, int _t, int _p, int _d) {

        s = _s;
        t = _t;
        p = _p;
        d = _d;
    }
};

bool event_comp (event a, event b) {

    if (a.s == b.s) {

        if (a.t == b.t) {

            return a.p < b.p;

        } else {

            return a.t > b.t;
        }

    } else {

        return a.s < b.s;
    }
}

int main () {

    //ifstream cin("input.txt");

    int n, m, k;
    cin >> n >> m >> k;

    vector <event> e;

    event aie(1, 0, 0, n);
    event aoe(n, 1, 0, n);
    ++k;

    e.push_back(aie);
    e.push_back(aoe);

    for (int i = 1; i < k; i++) {

        int a, b;
        cin >> a >> b;

        event ea(a, 0, i, b - a);
        event eb(b, 1, i, b - a);

        e.push_back(ea);
        e.push_back(eb);
    }

    sort(e.begin(), e.end(), event_comp);

    set <int> es;

    for (int i = 0; i < m * 2; i++) {

        es.insert(i);
    }

    vector <int> s(m, 0), p(k, -1);

    for (int i = 0; i < k * 2; i++) {

        if (e[i].t) {

            if (!~p[e[i].p]) continue;

            if (p[e[i].p] >= m) {

                s[p[e[i].p] - m] += e[i].d;
            }

            es.insert(p[e[i].p]);

        } else {

            if (!es.empty()) {

                int cs = *es.begin();
                es.erase(cs);

                p[e[i].p] = cs;
            }
        }
    }

    int a = 0;

    for (int i = 0; i < s.size(); i++) {

        if (s[a] > s[i]) {

            a = i;
        }
    }

    cout << s[a] << ' ' << a + 1;
}
