#include <stdio.h>
#include <bits/stdc++.h>

#define X first
#define Y second
#define all(v) v.begin(), v.end()
#define SZ(v) (int)(v.size())
#define pb push_back

using namespace std;

typedef pair<int, int> ii;
typedef long long ll;

const int INF = 100000000;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
//    freopen("input.txt", "r", stdin);
    int n, m;
    cin>>n>>m;
    char a[n][m];
    for(int i=0; i<n; i++)
        for(int j=0; j<m; j++)
            cin>>a[i][j];
    int f[4][26][n][m];
    for(int c=0; c<26; c++) {
        for(int i=0; i<n; i++)
            for(int j=0; j<m; j++) {
                f[2][c][i][j]=f[0][c][i][j]=INF;
                if(j&&a[i][j-1]==c+'a')f[2][c][i][j]=1;
                else if(j&&f[2][c][i][j-1]<INF)f[2][c][i][j]=f[2][c][i][j-1]+1;
                if(i&&a[i-1][j]==c+'a')f[0][c][i][j]=1;
                else if(i&&f[0][c][i-1][j]<INF)f[0][c][i][j]=f[0][c][i-1][j]+1;
            }
        for(int i=n-1; i>=0; i--)
            for(int j=m-1; j>=0; j--) {
                f[3][c][i][j]=f[1][c][i][j]=INF;
                if(j<m-1&&a[i][j+1]==c+'a')f[3][c][i][j]=1;
                else if(j<m-1&&f[3][c][i][j+1]<INF)f[3][c][i][j]=f[3][c][i][j+1]+1;
                if(i<n-1&&a[i+1][j]==c+'a')f[1][c][i][j]=1;
                else if(i<n-1&&f[1][c][i+1][j]<INF)f[1][c][i][j]=f[1][c][i+1][j]+1;
            }
    }
    int q; cin>>q;
    while(q--) {
        int I,J;
        cin>>I>>J;
        --I; --J;
        int dist=INF;
        int p1,q1=J,p2=I,q2;
        for(int c1=0; c1<26; c1++)
            if(min(f[0][c1][I][J],f[1][c1][I][J])<INF)
                for(char c2=0; c2<26; c2++)
                    if(min(f[2][c2][I][J],f[3][c2][I][J])<INF&&c1!=c2) {
                        if(f[0][c1][I][J]+f[2][c2][I][J]<dist) {
                            dist=f[0][c1][I][J]+f[2][c2][I][J];
                            p1=I-f[0][c1][I][J];
                            q2=J-f[2][c2][I][J];
                        }
                        if(f[0][c1][I][J]+f[3][c2][I][J]<dist) {
                            dist=f[0][c1][I][J]+f[3][c2][I][J];
                            p1=I-f[0][c1][I][J];
                            q2=J+f[3][c2][I][J];
                        }
                        if(f[1][c1][I][J]+f[2][c2][I][J]<dist) {
                            dist=f[1][c1][I][J]+f[2][c2][I][J];
                            p1=I+f[1][c1][I][J];
                            q2=J-f[2][c2][I][J];
                        }
                        if(f[1][c1][I][J]+f[3][c2][I][J]<dist) {
                            dist=f[1][c1][I][J]+f[3][c2][I][J];
                            p1=I+f[1][c1][I][J];
                            q2=J+f[3][c2][I][J];
                        }
                    }
        if(dist<INF)cout<<p1+1<<' '<<q1+1<<' '<<p2+1<<' '<<q2+1<<"\n";
        else cout<<-1<<"\n";
    }
    return 0;
}
