#include <bits/stdc++.h>
#define F first
#define S second
#define eps 1e-9
#define LL long long
#define MP make_pair
#define PB push_back
#define PPB pop_back          
#define PII pair<int, int>
#define sz(a) (int)(a.size())
#define ULL unsigned long long
using namespace std;

const int INF = 1e9 + 7;
const LL BINF = 1e18 + 7;
const int N = 301;
vector<int> v[N];
bool know[N][N];
int cost[N][N];
int fl[N][N];
int lang[N];
int n, k;

int main () {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	cin >> n >> k;
	for(int i = 1; i <= n; ++ i) {
		for(int j = 1; j <= n; ++ j) {
			cost[i][j] = INF;
			fl[i][j] = INF;
		}
		cost[i][i] = 0;
		fl[i][i] = 0;
	}
	for(int i = 1; i <= n; ++ i) {
		int cnt;
		cin >> cnt;
		for(int j = 1; j <= cnt; ++ j) {
			int a;
			cin >> a;
			lang[a] ++;
			know[i][a] = 1;
			v[i].PB(a);
		}
	}
	for(int i = 1; i <= n; ++ i) {
		for(int j = i + 1; j <= n; ++ j) {
			for(int k = 0; k < v[i].size(); ++ k) {
				int cur = v[i][k];
				if(know[j][cur]) {
					cost[i][j] = min(cost[i][j], lang[cur] - 1);
					cost[j][i] = cost[i][j];
				}
			}
		}
	}
	for(int i = 1; i <= n; ++ i) {
		for(int j = 1; j <= n; ++ j) {
			if(i == j) {
				continue;
			}
			for(int k = 1; k <= n; ++ k) {
				cost[i][j] = min(cost[i][j], cost[i][k] + cost[k][j]);
				cost[j][i] = cost[i][j];
			}
		}
	}
	for(int i = 1; i <= n; ++ i) {
		for(int j = 1; j <= n; ++ j) {
			if(cost[i][j] == INF) {
				cout << "-1 ";
				continue;
			}
			if(i != j) {
				cout << cost[i][j] + 1 << " ";
			}
			else {
				cout << 0 << " ";
			}
		}
		cout << endl;
	}
}