#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define fi first
#define se second
#define rep(i,x,y) for(int i = x; i <= y; ++i)
#define repr(i,x,y) for(int i = x; i >= y; --i)
#define forn(i,x,y) for(int i = x; i <= y; ++i)
#define forev(i,x,y) for(int i = x; i >= y; --i)
#define sz(x) (int)(x.size())
#define all(x) x.begin(), x.end()
                    
typedef long long ll;

using namespace std;

const int N = (int)(5e5) + 322;
const int maxn = (int)(5e5) + 100;
const int INF = (int)(1e9) + 7;
const double eps = 1e-9;

int n, m;

string s[N];

// 0 -> up
// 1 -> down
// 2 -> left 
// 3 -> right

struct point {
	int x, y, mn;
	point() {
		x = 0, y = 0, mn = INF;
	}
}; 

inline void upd(point &a, int x, int y, int mn) {
	if (x <= 0 || x > n || y <= 0 || y > m) return;
	if (mn > a.mn) return;
	a.mn = mn;
	a.x = x;
	a.y = y;
}

vector <vector <vector <vector <int> > > > dp;

int main () {
	ios_base :: sync_with_stdio(false); cin.tie(0);
//	freopen(".in", "r", stdin);
		
	cin >> n >> m;
	rep(i, 1, n) {
		cin >> s[i];
		s[i] = '#' + s[i];
	}
	dp.resize(n + 2);
	forn (i, 0, n + 1) {
		dp[i].resize(m + 2);
		forn (j, 0, m + 1) {
			dp[i][j].resize(26);
			forn (k, 0, 25)
				dp[i][j][k].resize(4);
		}
	}
		
	rep(i, 1, n) {
		rep(j, 1, m) {
			rep(ch, 0, 25) {
				dp[i][j][ch][0] = dp[i - 1][j][ch][0] + 1;				
				dp[i][j][ch][2] = dp[i][j - 1][ch][2] + 1;
			}
			dp[i][j][s[i][j] - 97][0] = 0;
			dp[i][j][s[i][j] - 97][2] = 0; 
		}
	}
	repr(i, n, 1) {
		repr(j, m, 1) {
			rep(ch, 0, 25) {
				dp[i][j][ch][1] = dp[i + 1][j][ch][1] + 1;
				dp[i][j][ch][3] = dp[i][j + 1][ch][3] + 1; 
			}
			dp[i][j][s[i][j] - 97][1] = 0;
			dp[i][j][s[i][j] - 97][3] = 0;
		}
	}
// 0 -> up
// 1 -> down
// 2 -> left 
// 3 -> right
	
	int q; cin >> q;
	rep(ii, 1, q) {
		int x, y; cin >> x >> y;
		int ch = s[x][y] - 97, mn = INF;
		int x1, y1, x2, y2;
		rep(i, 0, 25) {
			point ud;
			upd(ud, x - dp[x - 1][y][i][0] - 1, y, dp[x - 1][y][i][0] + 1);
			upd(ud, x + dp[x + 1][y][i][1] + 1, y, dp[x + 1][y][i][1] + 1);
			if (ud.mn == INF) continue;
			rep(j, 0, 25) {
				if (i == j) continue;
				point lr;
				upd(lr, x, y + dp[x][y + 1][j][3] + 1, dp[x][y + 1][j][3] + 1);
				upd(lr, x, y - dp[x][y - 1][j][2] - 1, dp[x][y - 1][j][2] + 1);
				if (lr.mn == INF) continue;
				if (lr.mn + ud.mn < mn) {
					mn = lr.mn + ud.mn;
					x1 = lr.x;
					y1 = lr.y;
					x2 = ud.x;
					y2 = ud.y;
				}						
			}																
		}				
		if (mn == INF) {
			cout << -1 << endl;
			continue;
		}
		cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << endl;
	} 
	return 0;
}