#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = (int) 5e5 + 5;
const int mod = (int) 1e9 + 7;

vector<vector <int> > r[26], c[26];
vector<vector <int> > a;
int n, m, d[26];

int main () {
        scanf ("%d%d", &n, &m);
        a.resize(n + 1);
        for(int i = 0; i < 26; ++i)
        {
                r[i].resize(n + 1);
                c[i].resize(n + 1);
        }
        for (int i = 1; i <= n; i++) {
                a[i].resize (m + 1);
                for (int l = 0; l < 26; l++) {
                        r[l][i].resize (m + 1);
                        c[l][i].resize (m + 1);
                }
                scanf ("\n");
                for (int j = 1; j <= m; j++) {
                        char ch;
                        scanf ("%c", &ch);
                        a[i][j] = ch - 'a';
                }
        }
        for (int i = 1; i <= n; i++) {
                for (int l = 0; l < 26; l++) {
                        d[l] = -mod;
                }
                for (int j = 1; j <= m; j++) {
                        for (int l = 0; l < 26; l++) {
                                r[l][i][j] = d[l];
                        }
                        d[a[i][j]] = j;
                }
                for (int l = 0; l < 26; l++) {
                        d[l] = mod;
                }
                for (int j = m; j >= 1; j--) {
                        for (int l = 0; l < 26; l++) {
                                if (abs (r[l][i][j] - j) > abs (d[l] - j)) {
                                        r[l][i][j] = d[l];
                                }
                        }
                        d[a[i][j]] = j;
                }
        }
        for (int j = 1; j <= m; j++) {
                for (int l = 0; l < 26; l++) {
                        d[l] = -mod;
                }
                for (int i = 1; i <= n; i++) {
                        for (int l = 0; l < 26; l++) {
                                c[l][i][j] = d[l];
                        }
                        d[a[i][j]] = i;
                }
                for (int l = 0; l < 26; l++) {
                        d[l] = mod;
                }
                for (int i = n; i >= 1; i--) {
                        for (int l = 0; l < 26; l++) {
                                if (abs (c[l][i][j] - i) > abs (d[l] - i)) {
                                        c[l][i][j] = d[l];
                                }
                        }
                        d[a[i][j]] = i;
                }
        }
        int query;
        scanf ("%d", &query);
        while (query--) {
                int i, j, ans = -1, ansi, ansj, ansii, ansjj;
                scanf ("%d%d", &i, &j);
                for (int x = 0; x < 26; x++) {
                        for (int y = 0; y < 26; y++) {
                                if (x == y || r[x][i][j] < 1 || r[x][i][j] > m || c[y][i][j] < 1 || c[y][i][j] > n) {
                                        continue;
                                }
                                if (ans == -1 || ans > abs (r[x][i][j] - j) + abs (c[y][i][j] - i)) {
                                        ans = abs (r[x][i][j] - j) + abs (c[y][i][j] - i);
                                        ansi = i; ansj = r[x][i][j];
                                        ansii = c[y][i][j]; ansjj = j;
                                }
                        }
                }
                if (ans == -1) {
                        puts ("-1");
                } else {
                        printf ("%d %d %d %d\n", ansi, ansj, ansii, ansjj);
                }
        }
        return 0;
}
