#ifdef _DEBUG
# include <iostream>
# include <algorithm>
# include <vector>
# include <queue>
# include <string>
# include <functional>
#else
#include <bits/stdc++.h>
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

int main()
{
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
#endif

  int n, m, k;
  cin >> n >> m >> k;

  vector<pair<pair<int, int>, int>> a;
  vector<int> c;
  for (int i = 0; i < k; i++)
  {
	int l, r;
	cin >> l >> r;

	a.push_back(make_pair(make_pair(l, 1), i));
	a.push_back(make_pair(make_pair(r, 0), i));
	c.push_back(l);
  }

  sort(a.begin(), a.end());

  priority_queue<int, vector<int>, greater<int>> q;
  vector<int> b(k, -1), d(m);

  for (int i = 0; i < m; i++)
	q.push(i);

  int cnt = m - 1;

  for (int i = 0; i < a.size(); i++)
  {
	if (a[i].first.second == 1)
	{
	  if (cnt > 0)
	  {
		cnt--;
	  }
	  else
	  {
		int t = q.top();
		q.pop();

		b[a[i].second] = t;
	  }
	}
	else
	{
	  if (b[a[i].second] == -1)
		cnt++;
	  else
	  {
		d[b[a[i].second]] += a[i].first.first - c[a[i].second];

		q.push(b[a[i].second]);
	  }
	}
  }

  int min = 0;
  for (int i = 0; i < m; i++)
	if (d[i] < d[min])
	  min = i;

  cout << d[min] << ' ' << min + 1 << endl;
}