#ifdef _DEBUG
# include <iostream>
# include <vector>
# include <string>
#else
#include <bits/stdc++.h>
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = (int)1e9 + 7;

int main()
{
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
#endif

  int n, m;
  cin >> n >> m;

  vector<string> a(n);
  for (int i = 0; i < n; i++)
	cin >> a[i];

  vector<vector<vector<vector<int>>>> b(n, vector<vector<vector<int>>>(m, vector<vector<int>>(26, vector<int>(2, 0))));

  for (int k = 0; k < 26; k++)
	for (int i = 0; i < n; i++)
	{
	int last = -1;

	for (int j = 0; j < m; j++)
	{
	  b[i][j][k][0] = last;

	  if (a[i][j] == 'a' + k)
		last = j;
	}

	for (int j = m - 1; j >= 0; j--)
	{
	  if ((b[i][j][k][0] == -1 || j - b[i][j][k][0] > last - j) && last != j)
		b[i][j][k][0] = last;

	  if (a[i][j] == 'a' + k)
		last = j;
	}
	}

  for (int k = 0; k < 26; k++)
	for (int j = 0; j < m; j++)
	{
	  int last = -1;

	  for (int i = 0; i < n; i++)
	  {
		b[i][j][k][1] = last;

		if (a[i][j] == 'a' + k)
		  last = i;
	  }

	  for (int i = n - 1; i >= 0; i--)
	  {
		if ((b[i][j][k][1] == -1 || j - b[i][j][k][1] > last - j) && last != i)
		  b[i][j][k][1] = last;

		if (a[i][j] == 'a' + k)
		  last = i;
	  }
	}

  int q;
  cin >> q;

  for (int _i = 0; _i < q; _i++)
  {
	int x, y;

	cin >> x >> y;

	x--; y--;

	int min = INF;
	pair<int, int> res;
	for (int i = 0; i < 26; i++)
	  for (int j = 0; j < 26; j++)
		if (i != j)
		{
		  if (abs(y - b[x][y][i][0]) + abs(x - b[x][y][j][1]) < min && b[x][y][i][0] != -1 && b[x][y][j][1] != -1)
		  {
			min = abs(y - b[x][y][i][0]) + abs(x - b[x][y][j][1]);
			res = make_pair(b[x][y][i][0], b[x][y][j][1]);
		  }
		}

	if (min == INF)
	  cout << -1 << endl;
	else
	  cout << x + 1 << ' ' << res.first + 1 << ' ' << res.second + 1 << ' ' << y + 1 << endl;
  }
}