#include<bits/stdc++.h>

using namespace std;


const int MAXN = 500001;
int n, m;
string s[MAXN];
vector<int> last[4][MAXN];
int dx[4] = {0, 0, 1, -1};
int dy[4] = {1, -1, 0, 0};


int main() {
    ios::sync_with_stdio(false);
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (int k = 0; k < 4; k++) {
        for (int i = 0; i < n; i++) {
            last[k][i].resize(m);
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            last[0][i][j] = -1;
            if (j) {
                last[0][i][j] = last[0][i][j - 1];
                if (s[i][j - 1] != s[i][j]) {
                    last[0][i][j] = j - 1;
                }
            }
            last[2][i][j] = -1;
            if (i) {
                last[2][i][j] = last[2][i - 1][j];
                if (s[i - 1][j] != s[i][j]) {
                    last[2][i][j] = i - 1;
                }
            }
        }
        for (int j = m - 1; j >= 0; j--) {
            last[1][i][j] = -1;
            if (j < m - 1) {
                last[1][i][j] = last[1][i][j + 1];
                if (s[i][j + 1] != s[i][j]) {
                    last[1][i][j] = j + 1;
                }
            }
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = 0; j < m; j++) {
            last[3][i][j] = -1;
            if (i < n - 1) {
                last[3][i][j] = last[3][i + 1][j];
                if (s[i + 1][j] != s[i][j]) {
                    last[3][i][j] = i + 1;
                }
            }
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        vector<int> v;
        for (int k = 0; k < 4; k++) {
            int x2 = x + dx[k];
            int y2 = y + dy[k];
            if (x2 < 0 || y2 < 0 || x2 >= n || y2 >= m) {
                continue;
            }
            v.push_back(s[x2][y2] - 'a');
        }
        int ans = 1000000000;
        pair<int, int> al, ar;
        if (y > 0) {
            int dist = 1;
            char c = s[x][y - 1];
            int f = -1;
            pair<int, int> a = make_pair(x, y - 1);
            pair<int, int> b;
            if (x < n - 1) {
                if (s[x + 1][y] != c) {
                    f = 1;
                    b = make_pair(x + 1, y);
                } else {
                    int kt = last[3][x + 1][y];
                    if (kt != -1) {
                        f = kt - x;
                        b = make_pair(kt, y);
                    }
                }
            }
            if (x > 0) {
                if (s[x - 1][y] != c) {
                    f = 1;
                    b = make_pair(x - 1, y);
                } else {
                    int kt = last[2][x - 1][y];
                    if (kt != -1) {
                        if (f == -1 || x - kt < f) {
                            f = x - kt;
                            b = make_pair(kt, y);
                        }
                    }
                }
            }
            if (f != -1) {
                dist += f;
                if (dist < ans) {
                    ans = dist;
                    al = a;
                    ar = b;
                }
            }
        }
        if (y < m - 1) {
            int dist = 1;
            char c = s[x][y + 1];
            int f = -1;
            pair<int, int> a = make_pair(x, y + 1);
            pair<int, int> b;
            if (x < n - 1) {
                if (s[x + 1][y] != c) {
                    f = 1;
                    b = make_pair(x + 1, y);
                } else {
                    int kt = last[3][x + 1][y];
                    if (kt != -1) {
                        f = kt - x;
                        b = make_pair(kt, y);
                    }
                }
            }
            if (x > 0) {
                if (s[x - 1][y] != c) {
                    f = 1;
                    b = make_pair(x - 1, y);
                } else {
                    int kt = last[2][x - 1][y];
                    if (kt != -1) {
                        if (f == -1 || x - kt < f) {
                            f = x - kt;
                            b = make_pair(kt, y);
                        }
                    }
                }
            }
            if (f != -1) {
                dist += f;
                if (dist < ans) {
                    ans = dist;
                    al = a;
                    ar = b;
                }
            }
        }
        if (x > 0) {
            int dist = 1;
            char c = s[x - 1][y];
            int f = -1;
            pair<int, int> a = make_pair(x - 1, y);
            pair<int, int> b;
            if (y < m - 1) {
                if (s[x][y + 1] != c) {
                    f = 1;
                    b = make_pair(x, y + 1);
                } else {
                    int kt = last[1][x][y + 1];
                    if (kt != -1) {
                        f = kt - y;
                        b = make_pair(x, kt);
                    }
                }
            }
            if (y > 0) {
                if (s[x][y - 1] != c) {
                    f = 1;
                    b = make_pair(x, y - 1);
                } else {
                    int kt = last[0][x][y - 1];
                    if (kt != -1) {
                        if (f == -1 || y - kt < f) {
                            f = y - kt;
                            b = make_pair(x, kt);
                        }
                    }
                }
            }
            if (f != -1) {
                dist += f;
                if (dist < ans) {
                    ans = dist;
                    al = a;
                    ar = b;
                }
            }
        }
        if (x < n - 1) {
            int dist = 1;
            char c = s[x + 1][y];
            int f = -1;
            pair<int, int> a = make_pair(x + 1, y);
            pair<int, int> b;
            if (y < m - 1) {
                if (s[x][y + 1] != c) {
                    f = 1;
                    b = make_pair(x, y + 1);
                } else {
                    int kt = last[1][x][y + 1];
                    if (kt != -1) {
                        f = kt - y;
                        b = make_pair(x, kt);
                    }
                }
            }
            if (y > 0) {
                if (s[x][y - 1] != c) {
                    f = 1;
                    b = make_pair(x, y - 1);
                } else {
                    int kt = last[0][x][y - 1];
                    if (kt != -1) {
                        if (f == -1 || y - kt < f) {
                            f = y - kt;
                            b = make_pair(x, kt);
                        }
                    }
                }
            }
            if (f != -1) {
                dist += f;
                if (dist < ans) {
                    ans = dist;
                    al = a;
                    ar = b;
                }
            }
        }
        if (ans == 1000000000) {
            cout << -1 << endl;
        } else {
            cout << al.first + 1 << ' ' << al.second + 1 << ' ' << ar.first + 1 << ' ' << ar.second + 1 << endl;
        }
    }
    return 0;
}
/*
3 4
abbb
baab
babb
4
1 1
1 4
3 1
3 4
*/
