#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 300;

bool speak[MAXN][MAXN];
int d[MAXN][MAXN];
const int INF = 10000000;

int main() {
	int n, k;
	cin >> n >> k;
	vector<vector<int>> lgs(n);
	vector<int> cnt(k);

	for (int i = 0; i < n; i++) {
		int  x;
		cin >> x;
		for (int j = 0; j < x; j++) {
			int l;
			cin >> l;
			l--;
			cnt[l]++;
			lgs[i].push_back(l);
			speak[i][l] = true;
		}
	}


	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i != j)
				d[i][j] = INF;
			for (int l = 0; l < k; l++) {
				if (speak[i][l] && speak[j][l]) {
					d[i][j] = min(d[i][j], cnt[l]);
				}
			}
		}
	}

	for (k = 0; k < n; k++) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				d[i][j] = min(d[i][j], d[i][k] + d[k][j] - (k != i && k != j ? 1 : 0));
			}
		}
	}
    
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (d[i][j] == INF) {
				cout << -1 << " ";
			}
			else {
				cout << d[i][j] << " ";
			}
		}
		cout << endl;
	}

	//system("pause");

	return 0;
}