#include <iostream>
#include <set>
#include <algorithm>
#include <vector>

using namespace std;

const int maxn = 6e5;

int cnt[maxn];
int u[maxn];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, k;
    cin >> n >> m >> k;
    set<int> s;
    for (int i = 0; i < 2*m-1; ++i) {
        s.insert(i);
    }
    vector<pair<int, pair<bool, int>>> v;
    vector<int> t;
    for (int i = 0; i < k; ++i) {
        int a, b;
        cin >> a >> b;
        v.push_back({a, {1, i}});
        v.push_back({b, {0, i}});
        t.push_back(b-a);
    }
    sort(v.begin(), v.end());
    for (auto p: v) {
        if (p.second.first) {
            u[p.second.second] = *s.begin();
            s.erase(s.begin());
        } else {
            s.insert(u[p.second.second]);
        }
    }
    for (int i = 0; i < k; ++i) {
        cnt[u[i]] += t[i];
    }
    int mi = -1;
    for (int i = 0; i < m; ++i) {
        if (mi == -1 || (cnt[m-1+i] < cnt[m-1+mi])) {
            mi = i;
        }
    }
    cout << cnt[m-1+mi] << ' ' << mi+1 << '\n';
    return 0;
}
