#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>

using namespace std;

vector <pair <int, int> > pas;
int n, m, k;

#define f first
#define s second

int f(int pos)
{
    int cur = 1;
    multiset <int> go_back;
    int ans = 0;
    int ans_back = -1;
    int ans_come = -1;

    for (int i = 0; i < k; i++){
        int now = pas[i].f;
        for (auto c : go_back){
            if (c <= now){
                cur -= go_back.count(c);
                go_back.erase(c);
            }
        }
        if (cur < 2 * m){
            cur++;
            go_back.insert(pas[i].s);
        }
        if (ans_back == -1 && cur >= m + pos){
            ans_back = pas[i].s;
            ans_come = now;
            ans += ans_back - ans_come;
        }
        else{
            if (now >= ans_back){
                ans_come = -1;
                ans_back = -1;
            }
        }
    }
    return ans;
}

int main()
{
    cin >> n >> m >> k;
    pas.resize(k);
    for (int i = 0; i < k; i++){
        cin >> pas[i].first >> pas[i].second;
    }
    sort(pas.begin(), pas.end());
    int t = f(m);
    cout << t << " ";
    int l = -1;
    int r = m + 1;
    while (r - l > 1){
        int mid = (r + l) / 2;
        if(f(mid) == t){
            r = mid;
        }
        else{
            l = mid;
        }
    }
    if (r == m + 1){
        cout << m;
        return 0;
    }
    else{
        cout << r;
    }
    return 0;
}
