#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

typedef long long ll;

bool f(ll x){
    ll ans = 1;
    for (int i = 2; i * i <= x; i++){
        int temp = 0;
        while (x % i == 0){
            temp++;
            x /= i;
        }
        ans *= temp + 1;
        if (ans >= 100){
            return 1;
        }
    }
    if (x != 1){
        ans *= 2;
    }
    if (ans >= 100){
        return 1;
    }
    return 0;
}

int main()
{
    ll n;
    int c = 45360;
    cin >> n;
    if (n / 100 >= c){
        cout << ((n + c - 1) / c) * c;
        return 0;
    }

    for (ll i = n; i <= n + n / 100; i++){
        if (f(i)){
            cout << i;
            return 0;
        }
    }
    cout << -1;
    return 0;
}
