#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:25600000")
#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
using namespace std;

#define TASK ""

int solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	return solve();
};

const int MAXN = (int)2e5 + 7;

int l[MAXN], r[MAXN], ans[MAXN];

struct event{
	int who, type;
	bool operator < (const event &e){
		int x1 = (type == 1 ? l[who] : r[who]);
		int x2 = (e.type == 1 ? l[e.who] : r[e.who]);
		if (x1 != x2){
			return x1 < x2;
		}
		if (type == e.type){
			return who < e.who;
		}
		return type < e.type;
	}
};

pair<int, int> place[MAXN];
vector<event> g;

int solve() {
	int n, m, k;
	cin >> n >> m >> k;
	set<int> s1, s2;
	for (int i = 1; i <= m; i++) {
		s1.insert(i);
		s2.insert(i);
	}
	s1.erase(1);
	for (int i = 0; i < k; i++){
		scanf("%d%d", &l[i], &r[i]);
		g.push_back({ i, 1 });
		g.push_back({ i, -1 });
	}
	sort(g.begin(), g.end());
	for (auto e : g){
		if (e.type == 1){
			if (s1.empty()){
				if (s2.empty()){
					place[e.who] = { -1, -1 };
					continue;
				}
				int pos = *s2.begin();
				s2.erase(s2.begin());
				ans[pos] += r[e.who] - l[e.who];
				place[e.who] = { pos, 1 };
			}
			else{
				int pos = *s1.begin();
				s1.erase(s1.begin());
                place[e.who] = { pos, 0 };
			}
		}
		else{
			pair<int, int> p = place[e.who];
			if (p.second == -1) continue;
			if (p.second == 0){
				s1.insert(p.first);
			}
			else{
				s2.insert(p.first);
			}
		}
	}
	int ind = 0;
	ans[0] = 1e9 + 7;
	for (int i = m; i >= 1; i--){
		if (ans[i] <= ans[ind]){
			ind = i;
		}
	}
	cout << ans[ind] << ' ' << ind;
	return 0;
}
