#include <iostream>
#include <string>
#include <set>
#include <vector>
#include <algorithm>

using namespace std;



int main()
{
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    vector <string> A(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> A[i];
    }
    vector <set <pair <int, int> > > H(n);
    vector <set <pair <int, int> > > V(m);
    for (int i = 0; i < n; ++i)
    {
        char last = A[i][0];
        int s = 0;
        int f = 0;
        for (int j = 0; j < m; ++j)
        {
            if (last == A[i][j])
            {
                f = j;
            }
            if (last != A[i][j])
            {
                H[i].insert({ s, f });
                s = j;
                f = s;
                last = A[i][j];
            }
        }
        H[i].insert({ s, m - 1 });
    }
    for (int j = 0; j < m; ++j)
    {
        char last = A[0][j];
        int s = 0;
        int f = 0;
        for (int i = 0; i < n; ++i)
        {
            if (last == A[i][j])
            {
                f = i;
            }
            if (last != A[i][j])
            {
                V[j].insert({ s, f });
                s = i;
                f = i;
                last = A[i][j];
            }
        }
        V[j].insert({ s, n - 1 });
    }
    int q;
    cin >> q;
    for (int tk = 0; tk < q; ++tk)
    {
        int i, j;
        cin >> i >> j;
        --i;
        --j;
        vector <vector <pair <char, pair <int, int> > > > D(2);
        if (j + 1 < m)
        {
            D[0].push_back({ A[i][j + 1], { i, j + 1 } });
            auto it = H[i].upper_bound({ j + 1, 1e8 });
            if (it != H[i].end())
            {
                D[0].push_back({ A[i][it->first], { i, it->first } });
            }
        }
        if (j - 1 >= 0)
        {
            D[0].push_back({ A[i][j - 1], { i, j - 1 } });
            auto it = H[i].upper_bound({ j - 1, 1e8 });
            --it;
            if (it != H[i].begin())
            {
                --it;
                D[0].push_back({ A[i][it->second], { i, it->second } });
            }
        }
        if (i + 1 < n)
        {
            D[1].push_back({ A[i + 1][j], { i + 1, j } });
            auto it = V[j].upper_bound({ i + 1, 1e8 });
            if (it != V[j].end())
            {
                D[1].push_back({ A[it->first][j], { it->first, j } });
            }
        }
        if (i - 1 >= 0)
        {
            D[1].push_back({ A[i - 1][j], { i - 1, j } });
            auto it = V[j].upper_bound({ i - 1, 1e8 });
            --it;
            if (it != V[j].begin())
            {
                --it;
                D[1].push_back({ A[it->second][j], { it->second, j } });
            }
        }
            int mini = 1e9;
            int x1 = -1, y1 = -1, x2 = -1, y2 = -1;
            for (int l = 0; l < D[0].size(); ++l)
            {
                for (int lk = 0; lk < D[1].size(); ++lk)
                {
                    if (D[0][l].first != D[1][lk].first)
                    {
                        if (mini > abs(D[0][l].second.first - D[1][lk].second.first) + abs(D[0][l].second.second - D[1][lk].second.second))
                        {
                            mini = abs(D[0][l].second.first - D[1][lk].second.first) + abs(D[0][l].second.second - D[1][lk].second.second);
                            x1 = D[0][l].second.first;
                            y1 = D[0][l].second.second;
                            x2 = D[1][lk].second.first;
                            y2 = D[1][lk].second.second;
                        }
                    }
                }
            }
            if (x1 == -1)
            {
                cout << -1 << '\n';
            }
            else
            {
                cout << x1 + 1 << " " << y1 + 1 << " " << x2 + 1 << " " << y2 + 1 << '\n';
            }
    }
    return 0;
}