#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>
#include <map>
#include <bitset>
#include <string>
#include <string>

using namespace std;

typedef long long ll;

int solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int dd = (int)1e6 + 7;

char S[dd];
vector<int> A(1), B(1), C(1), D(1);

ll ax[dd], bx[dd], cx[dd], dx[dd];

int PR[dd], PC[dd];
int BR[dd], BC[dd];
int AA[5007][5007];

int solve() {
	int n, m, k;
	scanf("%d %d %d\n", &n, &m, &k);
	scanf("%s", S);

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			AA[i][j] = i * m + j;

	for (int i = 0; i < n; i++)
		PR[i] = i;
	for (int j = 0; j < m; j++)
		PC[j] = j;

	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; i++) {
		int q;
		scanf("%d", &q);
		A.push_back(q);
	}


	scanf("%d", &t);
	for (int i = 0; i < t; i++) {
		int q;
		scanf("%d", &q);
		B.push_back(q);
	}


	scanf("%d", &t);
	for (int i = 0; i < t; i++) {
		int q;
		scanf("%d", &q);
		C.push_back(q);
	}


	scanf("%d", &t);
	for (int i = 0; i < t; i++) {
		int q;
		scanf("%d", &q);
		D.push_back(q);
	}

	for (int i = 1; i < (int)A.size(); i++) {
		ax[i] = A[i];
	}
	for (int i = (int)A.size(); i <= k; i++) {
		ax[i] = (10007 * ax[i - 2] + 10009 * ax[i - 1] + 87277) % n;
	}


	for (int i = 1; i < (int)B.size(); i++) {
		bx[i] = B[i];
	}
	for (int i = (int)B.size(); i <= k; i++) {
		bx[i] = (10007 * bx[i - 2] + 10009 * bx[i - 1] + 87277) % m;
	}


	for (int i = 1; i < (int)C.size(); i++) {
		cx[i] = C[i];
	}
	for (int i = (int)C.size(); i <= k; i++) {
		cx[i] = (10007 * cx[i - 2] + 10009 * cx[i - 1] + 87277) % n;
	}



	for (int i = 1; i < (int)D.size(); i++) {
		dx[i] = D[i];
	}
	for (int i = (int)D.size(); i <= k; i++) {
		dx[i] = (10007 * dx[i - 2] + 10009 * dx[i - 1] + 87277) % m;
	}

	for (int i = 1; i <= k; i++) {
		if (S[i - 1] == 'c') {
			swap(PC[bx[i]], PC[dx[i]]);
		}
		if (S[i - 1] == 'r') {
			swap(PR[ax[i]], PR[cx[i]]);
		}
		if (S[i - 1] == 'f') {
			swap(AA[PR[ax[i]]][PC[bx[i]]], AA[PR[cx[i]]][PC[dx[i]]]);
		}
	}

	int pi = 1;
	int h = 0;
	int mod = (int)1e9 + 7;

	for (int i = 0; i < n; i++) {
		
		int pj = 1;
		
		for (int j = 0; j < m; j++) {
			int cur = AA[PR[i]][PC[j]];
			//printf("%d%c", cur, " \n"[j == m - 1]);
			
			h += (1ll * cur * pi % mod * pj) % mod;
			if (h >= mod) h -= mod;

			pj = (1ll * pj * 19) % mod;
		}

		pi = (1ll * pi * 17) % mod;
	}
	printf("%d\n", h);

	return 0;
}