#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int S = 1e6 + 7;
bool term[S];
int perk[S];
vector <int> ind[S];
int sz = 1;

int t[S][26];
int sum[S];

void kok(int v1, int v2)
{
    queue <pair <int, int> > q;
    q.push({v1, v2});
    while (!q.empty())
    {
        int v1 = q.front().first, v2 = q.front().second;
        q.pop();
        if (v1 == v2)
        {
            continue;
        }
        for (auto c: ind[v2])
        {
            ind[v1].push_back(c);
        }
        ind[v2].clear();
        for (int c = 0; c < 26; c++)
        {
            if (t[v1][c] == -1 && t[v2][c] != -1)
            {
                t[v1][c] = sz++;
            }
            if (t[v1][c] != -1 && t[v2][c] != -1)
            {
                if (!term[t[v1][c]])
                {
                    q.push({t[v1][c], t[v2][c]});
                }
                else
                {
                    q.push({0, t[v2][c]});
                }
            }
        }
    }
}

void add_gen(string s)
{
    int v = 0;
    for (auto c: s)
    {
        c -= 'a';
        if (t[v][c] == -1)
        {
            t[v][c] = sz++;
        }
        v = t[v][c];
    }
    term[v] = 1;
    kok(0, v);
}

void add_str(string s, int in)
{
    int v = 0;
    for (auto c: s)
    {
        c -= 'a';
        if (t[v][c] == -1)
        {
            t[v][c] = sz++;
        }
        v = t[v][c];
        if (term[v])
        {
            v = 0;
        }
    }
    ind[v].push_back(in);
}

int main()
{
    #ifdef ONPC
    //freopen("a.in", "r", stdin);
    //freopen("a.out", "w", stdout);
    //ifstream cin("a.in");
    //ofstream cout("a.out");
    #endif
    ios::sync_with_stdio(0);
    memset(t, -1, sizeof t);
    int q;
    cin >> q;
    string s;
    int last = 0;
    int sz = 1;
    for (int i = 0; i < q; i++)
    {
        char c;
        cin >> c;
        cin >> s;
        last %= (int) s.size();
        int cur = s.size();
        s += s;
        string t = "";
        for (int i = last; i < (int) last + cur; i++)
        {
            t += s[i];
        }
        s = t;
        if (c == '+')
        {
            add_gen(s);
        }
        else
        {
            add_str(s, sz++);
        }
        last = ind[0].size();
        cout << last << ' ';
        for (auto c: ind[0])
        {
            cout << c << ' ';
        }
        cout << '\n';
        ind[0].clear();
    }
}
