  Uses MATH;

  Const MAX_M = 2 * 1000000 + 100;
        SITING = -1;
        NO_PLACE = -2;
        e_exit = 1;
        e_enter = 2;
        MAX_TREE_SIZE = 50000000;

  Type tEvent = record
    tips , id , t : LongInt;
  end;

  function isSmaller ( const a , b : tEvent ) : Boolean;
  begin
    if ( a.t < b.t ) then
      exit ( true ) ;
    if ( a.t > b.t ) then
      exit ( false ) ;

    isSmaller := a.tips < b.tips;

  end;

  procedure qSort ( var A :Array of tEvent ; Size : LongInt ) ;
    procedure Sort ( l , r : LongInt ) ;
      var i , j : LongInt;
          tmp , piv : tEvent;
    begin
      i := l ;
      j := r ;
      piv := a [ l + random ( r - l ) ] ;
      repeat
        while ( isSmaller ( A[i] , piv ) ) do
          inc ( i );
        while ( isSmaller ( piv , A[j] ) ) do
          dec ( j ) ;
        if ( i <= j ) then
        begin
          tmp := A[i];
          A[i] := A[j];
          A[j] := tmp;
          inc ( i ) ;
          dec ( j ) ;
        end;
      until i>j;
      if ( i < r ) then
        Sort ( i , r ) ;
      if ( l < j ) then
        Sort ( l , j ) ;
    end;
  begin
    randomize();
    Sort ( 0 , Size - 1 ) ;
  end;


  var E : Array [ 1 .. MAX_M * 2 ] of tEvent;
      E_size : LongInt = 0 ;

  procedure addEvent ( t , time , id : LongInt ) ;
  begin
    inc ( E_size ) ;
    E[E_size].tips := t;
    E[E_size].t := time;
    E[E_size].id := id;
  end;


  // SEGMENT TREEEEEEEEEEEEEEEEEEE

  type tNode = record
    LSon , RSon : LongInt;
    L , R : LongInt;
    val : Int64;
  end;

  var T : array [ 1 .. MAX_TREE_SIZE ] of tNode ;
      tt : LongInt = 0 ;
  function NewNode ( l , r : LongInt ) : LongInt;
  begin
    if ( tt > MAX_TREE_SIZE ) then
      halt ( 69 ) ;

    inc ( tt ) ;
    T[tt].L := L;
    T[tt].R := R;
    T[tt].val := 0;

    NewNode := tt;
  end;

  function getVal ( v : LongInt ) : Int64;
  begin
    if ( v = 0 ) then
      exit ( 0 )
    else
      exit ( T[v].val ) ;
  end;

  procedure Modify ( v , x , delta : LongInt ) ;
    var med : LongInt;
  begin
    if ( T[v].L = T[v].R ) then
    begin
      T[v].val += delta;
    end
    else
    begin
      med := ( T[v].L + T[v].R ) div 2 ;

      if ( x <= med ) then
      begin
        if ( T[v].LSon = 0 ) then
          T[v].LSon := NewNode ( T[v].L , med ) ;
        Modify ( T[v].LSon , x , delta ) ;

      end
      else
      begin
        if ( T[v].RSon = 0 ) then
          T[v].RSon := NewNode ( med+1 , T[v].R ) ;
        Modify ( T[v].RSon , x , delta ) ;
      end;

      T[v].val := min ( GetVal ( T[v].LSon ) , GetVal ( T[v].RSon ) ) ;

    end;
  end;

  function GetMin ( v : LongInt ; var pl : LongInt ): Int64;
  begin
    GetMin := T[v].val;

    while ( T[v].L <> T[v].R ) do
    begin

      if ( GetVal ( T[v].LSon ) <= GetVal ( T[v].RSon ) ) then
      begin
        if ( T[v].LSon = 0 ) then
          T[v].LSon := NewNode ( T[v].L , ( T[v].L + T[v].R ) div 2 ) ;
        v := T[v].LSon
      end
      else
      begin
        if ( T[v].RSon = 0 ) then
          T[v].RSon := NewNode (  ( T[v].L + T[v].R ) div 2 + 1 , T[v].R ) ;
        v := T[v].RSon;
      end;

    end;

    pl := T[v].L;


  end;

  // =========================================



  var N , M , K : LongInt;


  var i : LongInt;
      A , B , Place : Array [ 1 .. MAX_M ] of LongInt;

      AnsRoot , Root : LongInt;

      tmp , c_place : LongInt;
      on_place : LongInt;

begin
  //writeLn ( SizeOF ( T ) / 1024 / 1024 :3:3, ' mb' ) ;

  readLn ( N , M , K ) ;


  for i := 1 to K do
  begin
    readLn ( A[i] , B[i] ) ;
    addEvent ( e_enter , A[i] , i ) ;
    addEvent ( e_exit  , B[i] , i ) ;
  end;

  qSort ( E , E_size ) ;

  on_place := 1;


  AnsRoot := NewNode ( 1 , M );
  Root := NewNode ( 1 , M );

  for i := 1 to E_size do
  begin

    if ( E[i].tips = e_enter ) then
    begin



      // Siting place
      if on_place < m then
      begin
        inc ( on_place ) ;
        Place[ E[i].id ] := SITING;
      end
      else
      begin
        tmp := GetMin ( Root , c_place ) ;
        if ( tmp = 0 ) then
        begin
          // free place
          Modify ( Root , c_place , +1 ) ;
          Modify ( AnsRoot , c_place , +(B[ E[i].id ] - A[ E[i].id ] ) );
          Place[ E[i].id ] := c_place;
        end
        else // NO_PLACE
          Place[ E[i].id ] := NO_PLACE;

      end;



    end
    else if ( E[i].tips = e_exit ) then
    begin
      if ( Place[ E[i].id ] = SITING ) then
        dec ( on_place )
      else if ( Place [ E[i].id ] > 0 ) then
      begin
        Modify ( Root , Place [ E[i].id ] , -1 ) ;
      end;

    end;


  end;

  tmp := GetMin ( AnsRoot , c_place ) ;
  writeLn ( tmp , ' ' , c_place ) ;

end.
