#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

#define int long long
int C = 50400;


signed main() {
    int n;
    cin >> n;
    int up = ((n + C - 1) / C) * C;
    if (up * 100 <= 101 * n) {
        cout << up << endl;
        return 0;
    }
    int max_up = floor(n * 1.01);
    vector <int> div(max_up + 10, -1);
    for (int i = 2; i <= max_up; i++) {
        if (div[i] == -1) {
            for (int j = i * 2; j <= max_up; j += i) {
                div[j] = i;
            }
        }
    }
    vector <int> num_div(max_up + 10, -1);
    num_div[1] = 1;
    for (int i = 2; i <= max_up; i++) {
        if (div[i] == -1) {
            num_div[i] = 2;
        } else {
            int dd = div[i];
            int deg = 0;
            int tm = i;
            while (tm % dd == 0) {
                deg++;
                tm /= dd;
            }
            num_div[i] = num_div[tm] * (deg + 1);
        }
    }
    for (int i = n; i <= max_up; i++) {
        if (num_div[i] >= 100) {
            cout << i << endl;
            return 0;
        }
    }
    cout << -1 << endl;
    return 0;
}
