#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:256000000")
#include<iostream>
#include<fstream>
#include<cstdio>
#include<cstdlib>
#include<ctime>
#include<cstring>
#include<string>
#include<map>
#include<set>
#include<vector>
#include<cmath>
#include<algorithm>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define forn(i, n) for (int i = 0; i < (n); ++i)
#define X first
#define Y second
#define y1 y111
#define psh push_back
#define all(a) a.begin(), a.end()

const int MAXN = (int)1e6 + 7;
const int MAXX = (int)5e3 + 7;
const int INF = (int)1e9 + 7;
const ll MOD = (ll)1e9 + 7;
const ll LINF = (ll)1e18 + 7;

void file() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
}

ll h, w, n;
ll t[MAXX][MAXX];
ll a[4][MAXN];
int indi[MAXX], indj[MAXX];
ll p17[MAXX];
ll p19[MAXX];

int main() {
	file();
	cin >> h >> w >> n;
	forn(i, h) {
		forn(j, w) {
			t[i][j] = i * w + j;
		}
	}
	forn(i, h) {
		indi[i] = i;
	}
	forn(i, w) {
		indj[i] = i;
	}
	string s;
	cin >> s;
	forn(i, 4) {
		int k;
		cin >> k;
		forn(j, k) {
			cin >> a[i][j];
		}
		if (i == 0 || i == 2) {
			for (int j = k; j < n; ++j) {
				a[i][j] = ((a[i][j - 2] * 10007) % h + (a[i][j - 1] * 10009) % h + 87277) % h;
			}
		} else { 
			for (int j = k; j < n; ++j) {
				a[i][j] = ((a[i][j - 2] * 10007) % w + (a[i][j - 1] * 10009) % w + 87277) % w;
			}
		}
	}
	forn(i, n) {
		if (s[i] == 'c') {
			int x = a[1][i];
			int y = a[3][i];
			swap(indi[x], indi[y]);
		}
		if (s[i] == 'r') {
			int x = a[0][i];
			int y = a[2][i];
			swap(indj[x], indj[y]);
		}
		if (s[i] == 'f') {
			int x1 = a[0][i];
			int y1 = a[1][i];
			int x2 = a[2][i];
			int y2 = a[3][i];
			swap(t[indi[x1]][indj[y1]], t[indi[x2]][indj[y2]]);
		}
	}

	ll p = 1;
	forn(i, h) {
		p17[i] = p;
		p = (p * 17) % MOD;
	}
	p = 1;
	forn(i, w) {
		p19[i] = p;
		p = (p * 19) % MOD;
	}
	ll ans = 0;
	/*forn(i, h) {
		forn(j, w) {
			int i1 = indi[i];
			int j1 = indj[j];
			cout << t[i1][j1] << " ";
		}
		cout << "\n";
	}*/
	forn(i, h) {
		forn(j, w) {
			int i1 = indi[i];
			int j1 = indj[j];
			ll tek = t[i1][j1];
			ll m17 = p17[i];
			ll m19 = p19[j];
			ans = (ans + ((((tek % MOD) * m17) % MOD) * m19) % MOD) % MOD;
		}
	}
	cout << ans;
	
	return 0;
}