#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define mp make_pair

#ifndef LOCAL
#define cerr if(0)cerr
#endif // LOCAL

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = int(1e9);
const ll INFll = ll(1e18);

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, m, k;
    cin >> n >> m >> k;
    vector<pair<int, int> > v(n);
    vector<pair<pair<ll, int>, int> > all;
    for (int i = 0; i < k; i++) {
        cin >> v[i].F >> v[i].S;
        all.pb({{v[i].S, 0}, i});
        all.pb({{v[i].F, 1}, i});
    }
    all.pb({{1, 1}, -1});
    all.pb({{n, 0}, -1});
    sort(all.begin(), all.end());
    int mx = 0;
    int cur = 0;
    for (int i = 0; i < all.size(); i++) {
        if (all[i].F.S) cur++;
        else cur--;
        mx = max(mx, cur);
    }

    if(mx <= m) {
        cout << "0 1" << endl;
        exit(0);
    }

    vector<ll> st(m, 0); // Time for seats
    set<int> fr;    // free seats
    vector<int > pos(k+1, -1); // where guy stands now
    vector<ll > frst(m, -1); // time when guy came here

    for(int i = 0; i < m; i++)
        fr.insert(i);
    cur = 0;
    for (int i = 0; i < all.size(); i++) {
//            cerr << all[i].F.F << " " << all[i].F.S << " ";
        if (all[i].F.S) {
            cur++;
            if(cur > m)
            {
                int p = *fr.begin();
                fr.erase(fr.begin());

                frst[p] = all[i].F.F;
                pos[all[i].S] = p;
//                    cerr << "added " << all[i].S << " " << p << " " << all[i].F.F << endl;
            }
        }
        else {
            if(all[i].S != -1 && pos[all[i].S] != -1)
            {
                int p = pos[all[i].S];
//                    cerr << "del " << all[i].S << " " << p << " " << all[i].F.F << endl;

                fr.insert(p);
                pos[all[i].S] = -1;
                st[p] += all[i].F.F - frst[p];
            }
            cur--;
        }
        mx = max(mx, cur);
    }

    cout << *min_element(st.begin(), st.end()) << " " << (min_element(st.begin(), st.end()) - st.begin() + 1) << endl;

    return 0;
}
