#include <bits/stdc++.h>
using namespace std;

const long long maxn = 6e3, len = 2e6;

long long a[maxn][maxn];
long long c[maxn], r[maxn];
long long q[len][4];

long long p17[maxn], p19[maxn];

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);

    for(long long i = 0; i < maxn; i++)
        r[i] = c[i] = i;

    long long h, w, n;
    cin >> h >> w >> n;

    for(long long i = 0; i < h; i++)
        for(long long j = 0; j < w; j++)
            a[i][j] = i*w+j;

    string s;
    cin >> s;

    long long k[4];
    for(long long i = 0; i < 4; i++){
        cin >> k[i];
        for(long long j = 0; j < k[i]; j++)
            cin >> q[j][i];
        long long mod = (i%2==0) ? h : w;
        for(long long j = k[i]; j < n; j++)
            q[j][i] = (q[j-2][i]*10007 + q[j-1][i]*10009 + 87277) % mod;
    }

    for(long long i = 0; i < n; i++){
        char ch = s[i];
        if(ch == 'c'){
            long long x = q[i][1], y = q[i][3];
            swap(c[x], c[y]);
            //swap(_c[x], _c[y]);
        }
        else if(ch == 'r'){
            long long x = q[i][0], y = q[i][2];
            swap(r[x], r[y]);
            //swap(_r[x], _r[y]);
        }
        else{
            long long x = q[i][0], y = q[i][1];
            long long _x = q[i][2], _y = q[i][3];
            swap(a[r[x]][c[y]], a[r[_x]][c[_y]]);
        }
        /*
        for(long long i = 0; i < h; i++){
            for(long long j = 0; j < w; j++){
                long long x = r[i], y = c[j];
                cout << a[x][y] << " ";
            }
            cout << endl;
        }
        cout << endl;
        */
    }

    p17[0] = p19[0] = 1;

    const long long mod = 1e9+7;

    for(long long i = 1; i < maxn; i++){
        p17[i] = p17[i-1]*17 % mod;
        p19[i] = p19[i-1]*19 % mod;
    }

    long long ans = 0;

    for(long long i = 0; i < h; i++){
        for(long long j = 0; j < w; j++){
            long long x = r[i], y = c[j];
            ans = (ans + a[x][y]*p17[i] % mod * p19[j] % mod) % mod;
            //cerr << a[i][j] << " " << p17[x] << " " << p19[y] << endl;
        }
    }

    cout << ans;

    return 0;
}
