#include <bits/stdc++.h>
#define ll long long
#define F first
#define S second
#define x sarhadth
#define y sdjaryjry

using namespace std;

int n, m, k;

int get(int x1, int y1, int x2, int y2, vector <vector <int> > v){
    if(max(x1, x2) > n || max(y1, y2) > m) return 0;
    return v[x2][y2] - v[x1 - 1][y2] - v[x2][y1 - 1] + v[x1 - 1][y1 - 1];
}

int main()
{
    cin >> n >> m;
    vector <vector <int> > dp1(n + 1, vector <int>(m + 1, 0)), dp2(n + 1, vector <int>(m + 1, 0)), t(n + 1, vector <int>(m + 1, 0));
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= m; j++){
            char c;
            cin >> c;
            if(c == 'b') t[i][j] = 1;
            dp1[i][j] = dp1[i - 1][j] + dp1[i][j - 1] - dp1[i - 1][j - 1] + t[i][j];
            dp2[i][j] = dp2[i - 1][j] + dp2[i][j - 1] - dp2[i - 1][j - 1] + (t[i][j] ^ 1);
        }
    }
    cin >> k;
    for(int i = 1; i <= k; i++){
        int a, b;
        cin >> a >> b;
        int l = 1, r = b - 1;
        vector <pair <int, int> > v1, v2;

        while(l < r){
            int mid = (l + r + 1) >> 1;
            if(get(a, mid, a, b - 1, dp1) == 0) r = mid - 1; else l = mid;
        }
        if(get(a, l, a, b - 1, dp1)) v1.push_back(make_pair(1, l));
        l = b + 1, r = m;
        while(l < r){
            int mid = (l + r) >> 1;
            if(get(a, b + 1, a, mid, dp1) == 0) l = mid + 1; else r = mid;
        }
        if(get(a, b + 1, a, l, dp1)) v1.push_back(make_pair(1, l));
        l = 1, r = b - 1;
        while(l < r){
            int mid = (l + r + 1) >> 1;
            if(get(a, mid, a, b - 1, dp2) == 0) r = mid - 1; else l = mid;
        }
        if(get(a, l, a, b - 1, dp2)) v1.push_back(make_pair(2, l));
        l = b + 1, r = m;
        while(l < r){
            int mid = (l + r) >> 1;
            if(get(a, b + 1, a, mid, dp2) == 0) l = mid + 1; else r = mid;
        }
        if(get(a, b + 1, a, l, dp2)) v1.push_back(make_pair(2, l));

        l = 1, r = a - 1;
        while(l < r){
            int mid = (l + r + 1) >> 1;
            if(get(mid, b, a - 1, b, dp1) == 0) r = mid - 1; else l = mid;
        }
        if(get(l, b, a - 1, b, dp1)) v2.push_back(make_pair(1, l));
        l = a + 1, r = n;
        while(l < r){
            int mid = (l + r) >> 1;
            if(get(a + 1, b, mid, b, dp1) == 0) l = mid + 1; else r = mid;
        }
        if(get(a + 1, b, l, b, dp1)) v2.push_back(make_pair(1, l));
        l = 1, r = a - 1;
        while(l < r){
            int mid = (l + r + 1) >> 1;
            if(get(mid, b, a - 1, b, dp2) == 0) r = mid - 1; else l = mid;
        }
        if(get(l, b, a - 1, b, dp2)) v2.push_back(make_pair(2, l));
        l = a + 1, r = n;
        while(l < r){
            int mid = (l + r) >> 1;
            if(get(a + 1, b, mid, b, dp2) == 0) l = mid + 1; else r = mid;
        }
        if(get(a + 1, b, l, b, dp2)) v2.push_back(make_pair(2, l));
        ll q = 0, ans1 = 0, ans2 = 0, minl = 1000000000;
        for(int i = 0; i < v1.size(); i++){
            for(int j = 0; j < v2.size(); j++){
                if(v1[i].F != v2[j].F){
                    if(minl > abs(b - v1[i].S) + abs(a - v2[j].S)){
                        minl = abs(b - v1[i].S) + abs(a - v2[j].S);
                        q = 1;
                        ans1 = i;
                        ans2 = j;
                    }
                }
            }
        }
        if(!q){
            cout << -1 << endl;
        } else {
            cout << a << ' ' << v1[ans1].S << ' ' << v2[ans2].S << ' ' << b << endl;
        }
    }
}
