#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <vector>
using namespace std;

const int s = 100000000;
bool r[s + 1];

int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	long long x;
	cin >> x;
	for (int i = 2; i <= s; i++)
		r[i] = true;
	for (int i = 2; i * i <= s; i++)
		if (r[i])
			for (int j = i * i; j <= s; j += i)
				r[j] = false;
	vector < int > p;
	for (int i = 2; i <= s; i++)
		if (r[i])
			p.push_back(i);
	long long X = x, Y, cnt, f;
	while (x <= X + X / 100){
		Y = x;
		cnt = 1;
		for (int i = 0; i < p.size() && Y != 1; i++){
			f = 0;
			while (Y % p[i] == 0)
				Y /= p[i], f++;
			cnt *= (f + 1);
		}
		if (Y != 1)
			cnt *= 2;
		if (cnt >= 100){
			cout << x;
			return 0;
		}
		x++;
	}
	cout << -1;
}
