#include <iostream>
#include <algorithm>
#include <set>
#include <vector>

using namespace std;

const long long INF = 1e18;

vector < pair <int, char> > str[1000500], stb[1000500];

vector < vector <char> > tab;
vector < vector <int> > posstr, posstb;
int n, m;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cerr.tie(0);
	cin >> n >> m;
	tab.resize(n + 4, vector <char>(m + 4));
	posstr.resize(n + 4, vector <int>(m + 4));
	posstb.resize(n + 4, vector <int>(m + 4));
	for (int i = 0; i < 4 + n; i++) {
		tab[i][0] = tab[i][m + 3] = '*';
	}
	for (int i = 1; i < 3 + n; i++) {
		tab[i][1] = tab[i][m + 2] = '#';
	}
	for (int j = 0; j < 4 + m; j++) {
		tab[0][j] = tab[n + 3][j] = '*';
	}
	for (int j = 1; j < 3 + m; j++) {
		tab[1][j] = tab[n + 2][j] = '#';
	}
	for (int i = 2; i < 2 + n; i++) {
		for (int j = 2; j < 2 + m; j++) {
			cin >> tab[i][j];
		}
	}
	for (int i = 0; i < n + 4; i++) {
		for (int j = 0; j < m + 4; j++) {
			if (j == 0) {
				str[i].push_back(make_pair(j, tab[i][j]));
			}
			else {
				if (str[i].back().second != tab[i][j]) {
					str[i].push_back(make_pair(j, tab[i][j]));
				}
			}
			if (i == 0) {
				stb[j].push_back(make_pair(i, tab[i][j]));
			}
			else {
				if (stb[j].back().second != tab[i][j]) {
					stb[j].push_back(make_pair(i, tab[i][j]));
				}
			}
			posstr[i][j] = str[i].size() - 1;
			posstb[i][j] = stb[j].size() - 1;
		}
	}
	int q;
	cin >> q;
	for (; q != 0; q--) {
		int x, y;
		cin >> y >> x;
		x += 1;
		y += 1;
		int ans = 1e7;
		int tr = posstr[y][x];
		int tb = posstb[y][x];
		int xl2, xl1, xr1, xr2;
		xl1 = x - 1;
		xr1 = x + 1;
		if (str[y][tr].first == x) {
			xl2 = str[y][tr - 1].first;
		}
		else {
			xl2 = str[y][tr].first;
		}
		xl2--;
		if (str[y][tr + 1].first == x + 1) {
			xr2 = str[y][tr + 2].first;
		}
		else {
			xr2 = str[y][tr + 1].first;
		}

		int yl2, yl1, yr1, yr2;
		yl1 = y - 1;
		yr1 = y + 1;
		if (stb[x][tb].first == y) {
			yl2 = stb[x][tb - 1].first;
		}
		else {
			yl2 = stb[x][tb].first;
		}
		yl2--;
		if (stb[x][tb + 1].first == y + 1) {
			yr2 = stb[x][tb + 2].first;
		}
		else {
			yr2 = stb[x][tb + 1].first;
		}

		int xans, yans;

		if (tab[y][xl2] != '*' && tab[y][xl2] != '#') {
			if (tab[yl2][x] != '*' && tab[yl2][x] != '#' && tab[yl2][x] != tab[y][xl2]) {
				if (ans > abs(y - yl2) + abs(x - xl2)) {
					ans = abs(y - yl2) + abs(x - xl2);
					xans = xl2;
					yans = yl2;
				}
			}
			if (tab[yl1][x] != '*' && tab[yl1][x] != '#' && tab[yl1][x] != tab[y][xl2]) {
				if (ans > abs(y - yl1) + abs(x - xl2)) {
					ans = abs(y - yl1) + abs(x - xl2);
					xans = xl2;
					yans = yl1;
				}
			}
			if (tab[yr2][x] != '*' && tab[yr2][x] != '#' && tab[yr2][x] != tab[y][xl2]) {
				if(ans > abs(y - yr2) + abs(x - xl2)) {
					ans = abs(y - yr2) + abs(x - xl2);
					xans = xl2;
					yans = yr2;
				}
			}
			if (tab[yr1][x] != '*' && tab[yr1][x] != '#' && tab[yr1][x] != tab[y][xl2]) {
				if (ans > abs(y - yr1) + abs(x - xl2)) {
					ans = abs(y - yr1) + abs(x - xl2);
					xans = xl2;
					yans = yr1;
				}
			}
		}




		xl2 = xl1;
		if (tab[y][xl2] != '*' && tab[y][xl2] != '#') {
			if (tab[yl2][x] != '*' && tab[yl2][x] != '#' && tab[yl2][x] != tab[y][xl2]) {
				if (ans > abs(y - yl2) + abs(x - xl2)) {
					ans = abs(y - yl2) + abs(x - xl2);
					xans = xl2;
					yans = yl2;
				}
			}
			if (tab[yl1][x] != '*' && tab[yl1][x] != '#' && tab[yl1][x] != tab[y][xl2]) {
				if (ans > abs(y - yl1) + abs(x - xl2)) {
					ans = abs(y - yl1) + abs(x - xl2);
					xans = xl2;
					yans = yl1;
				}
			}
			if (tab[yr2][x] != '*' && tab[yr2][x] != '#' && tab[yr2][x] != tab[y][xl2]) {
				if (ans > abs(y - yr2) + abs(x - xl2)) {
					ans = abs(y - yr2) + abs(x - xl2);
					xans = xl2;
					yans = yr2;
				}
			}
			if (tab[yr1][x] != '*' && tab[yr1][x] != '#' && tab[yr1][x] != tab[y][xl2]) {
				if (ans > abs(y - yr1) + abs(x - xl2)) {
					ans = abs(y - yr1) + abs(x - xl2);
					xans = xl2;
					yans = yr1;
				}
			}
		}





		xl2 = xr1;
		if (tab[y][xl2] != '*' && tab[y][xl2] != '#') {
			if (tab[yl2][x] != '*' && tab[yl2][x] != '#' && tab[yl2][x] != tab[y][xl2]) {
				if (ans > abs(y - yl2) + abs(x - xl2)) {
					ans = abs(y - yl2) + abs(x - xl2);
					xans = xl2;
					yans = yl2;
				}
			}
			if (tab[yl1][x] != '*' && tab[yl1][x] != '#' && tab[yl1][x] != tab[y][xl2]) {
				if (ans > abs(y - yl1) + abs(x - xl2)) {
					ans = abs(y - yl1) + abs(x - xl2);
					xans = xl2;
					yans = yl1;
				}
			}
			if (tab[yr2][x] != '*' && tab[yr2][x] != '#' && tab[yr2][x] != tab[y][xl2]) {
				if (ans > abs(y - yr2) + abs(x - xl2)) {
					ans = abs(y - yr2) + abs(x - xl2);
					xans = xl2;
					yans = yr2;
				}
			}
			if (tab[yr1][x] != '*' && tab[yr1][x] != '#' && tab[yr1][x] != tab[y][xl2]) {
				if (ans > abs(y - yr1) + abs(x - xl2)) {
					ans = abs(y - yr1) + abs(x - xl2);
					xans = xl2;
					yans = yr1;
				}
			}
		}



		xl2 = xr2;
		if (tab[y][xl2] != '*' && tab[y][xl2] != '#') {
			if (tab[yl2][x] != '*' && tab[yl2][x] != '#' && tab[yl2][x] != tab[y][xl2]) {
				if (ans > abs(y - yl2) + abs(x - xl2)) {
					ans = abs(y - yl2) + abs(x - xl2);
					xans = xl2;
					yans = yl2;
				}
			}
			if (tab[yl1][x] != '*' && tab[yl1][x] != '#' && tab[yl1][x] != tab[y][xl2]) {
				if (ans > abs(y - yl1) + abs(x - xl2)) {
					ans = abs(y - yl1) + abs(x - xl2);
					xans = xl2;
					yans = yl1;
				}
			}
			if (tab[yr2][x] != '*' && tab[yr2][x] != '#' && tab[yr2][x] != tab[y][xl2]) {
				if (ans > abs(y - yr2) + abs(x - xl2)) {
					ans = abs(y - yr2) + abs(x - xl2);
					xans = xl2;
					yans = yr2;
				}
			}
			if (tab[yr1][x] != '*' && tab[yr1][x] != '#' && tab[yr1][x] != tab[y][xl2]) {
				if (ans > abs(y - yr1) + abs(x - xl2)) {
					ans = abs(y - yr1) + abs(x - xl2);
					xans = xl2;
					yans = yr1;
				}
			}
		}
		
		if (ans == 1e7) {
			cout << -1 << endl;
		}
		else {
			cout << yans - 1 << " " << x - 1 << " " << y - 1 << " " << xans - 1 << endl;
		}
		/*int ans = 1e7;
		int tr = posstr[x][y];
		int tb = posstb[x][y];
		int pos1 = x--;
		if (pos1 != -1) {
			int pos2 = y - 1;
			if (pos2 != -1 && tab[pos1][y] != tab[x][pos2]) {
				ans = min(ans, abs(pos1 - x) + abs(pos2 - y));
			}

			if (stb[y][tb].first == y) {
				pos2 = tb--;
				if (tb != -1) {
					pos2 = stb[y][pos2].first - 1;
				}
			}
			else {
				pos2 = stb[y][tb].first - 1;
			}
			if (pos2 != -1 && tab[pos1][y] != tab[x][pos2]) {
				ans = min(ans, abs(pos1 - x) + abs(pos2 - y));
			}


			pos2 = y + 1;
			if (pos2 != m + 1 && tab[pos1][y] != tab[x][pos2]) {
				ans = min(ans, abs(pos1 - x) + abs(pos2 - y));
			}
			if (tb + 1 == stb[y].size()) {
				pos2 = m + 1;
			}
			else {
				if (pos2
				tb++;
				pos2 = 
			}

		}*/
	}




	
	
}