#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <algorithm>
#include <cmath>

using namespace std;

int fact(long long n){
	int ans = 2;
	for (int i = 2; i*i <= n; i++){
		int k = 0;
		while (n%i == 0){
			n /= i;
			k++;
		}
		ans *= k + 1;
	}
	return ans;
}

int main(){
	long long x;
	scanf("%lld", &x);
	if (x > 100000000){
		printf("%lld", x - (x % 45360) + 45360);
		return 0;
	}
	for (int i = x; i*100 <= x*101; i++){
		if (fact(i) > 99){
			printf("%lld", i);
			return 0;
		}
	}
	printf("-1");
	return 0;
}