#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

const double EPS = 1e-9;
typedef long long ll;
const int sz = 5e2;
const int INF = 1e9;

ll a, n;

ll get(ll arg) {
	ll p = 1;
	ll b = a;
	ll res = 0;
	while (b != 0 || arg != 0) {
		if ((b % 2) != (arg % 2)) {
			res += p;
		}
		b /= 2;
		arg /= 2;
		p *= 2;
	}
	return res;
}

int main() {
#ifdef MINE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int t;
	cin >> t;
	for (int T = 0; T < t; T++) {
		cin >> a >> n;
		ll down = (a / n) * n;
		ll up = down + n;
		cout << min(get(down), get(up)) << endl;
	}
	return 0;
}