#include <iostream>
#include <string>
#include <set>
#include <queue>
#include <stack>
using namespace std;
const int alph=26;
struct bor
{
    bool term;
    string word;
    bor* edge[alph];
    bor()
    {
        for (int i=0; i<alph;i++)
        {
            edge[i]=nullptr;
            term=0;
        }
    }
};

void add(bor *root,string s,int k)
{
    k=k%s.length();
    for (int i=k;i<s.length();i++)
    {
        int sym=s[i]-'a';
        if (!root->edge[sym])
        {
            root->edge[sym]= new bor;
        }
        root=root->edge[sym];
    }
    for (int i=0;i<k;i++)
    {
        int sym=s[i]-'a';
        if (!root->edge[sym])
        {
            root->edge[sym]= new bor;
        }
        root=root->edge[sym];
    }
    root->term=1;
    root->word=s;
}

bool check(string s, int k, bor* r)
{
    k=k%s.length();
    bor* R=r;
    for (int i=k;i<s.length();i++)
    {
        if (r->term)
            r=R;
        if (!r->edge[s[i]-'a'])
            return 0;
        else r=r->edge[s[i]-'a'];
    }
    for (int i=0;i<k;i++)
    {
        if (r->term)
            r=R;
        if (!r->edge[s[i]-'a'])
            return 0;
        else r=r->edge[s[i]-'a'];
    }
    if (r->term)
        return 1;
    return 0;
}

int main()
{
    bor *r=new bor;
    int n;
    cin>>n;
    int k=0, j=1;
    set <pair<string,pair <int,int> > > sets;
    for (int i=0;i<n;i++)
    {
        char c;
        cin>>c;
        if (c=='?')
        {
            string s;
            cin>>s;
            if (check(s,k,r))
            {
                cout<<1<<' '<<j<<endl;
                k=1;
            }
            else
            {
                cout<<0<<endl;
                sets.insert({s,{j,k}});
                k=0;
            }
            j++;
        }
        if (c=='+')
        {
            string s;
            cin>>s;
            add(r,s,k);
            queue<int> ans;
            stack<pair<string,pair<int,int> > > as;
            for (set<pair<string,pair<int,int> > >::iterator it=sets.begin();it!=sets.end();it++)
            {
                if (check((*it).first,(*it).second.second,r))
                {
                    ans.push((*it).second.first);
                    as.push(*it);
                }
            }
            while(!as.empty())
            {
                sets.erase(as.top());
                as.pop();
            }
            cout<<ans.size()<<' ';
            k=ans.size();
            while (!ans.empty())
            {
                cout<<ans.front()<<' ';
                ans.pop();
            }
            cout<<endl;
        }
    }
    return 0;
}

/*
5
? abcabd
+ abc
? abcabc
? dabdab
+ abd */
