#include <iostream>

using namespace std;

long long mod = 1;

long long val(long long x) {
    return (x % mod + mod - 1) % mod + 1;
}

long long q(long long i) {
  cout << "? " << i << endl;
  cout.flush();
  long long x;
  cin >> x;
  return x;
}

int main() {
  for (int i = 0; i < 18; i++) mod *= 10;

  long long x, m;
  cin >> x >> m;
  mod -= m;
  long long s = val(x - q(1) + 1);

  long long left = s - m;
  long long right = s;

  while (left <= right) {
    long long middle = (left + right) / 2;
    long long res = q(val(middle));
    if (left == right && res != x) {
        cout << "! -1" << endl;
        cout.flush();
        return 0;
    }
    if (res < x)
        left = middle + 1;
    if (res > x)
        right = middle - 1;
    if (res == x) {
        cout << "! " << val(middle) << endl;
        cout.flush();
        return 0;
    }
  }
}
