#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;


vector<int> cnt;
bool cmp(int a, int b){
    if (cnt[a] != cnt[b])
        return cnt[a] < cnt[b];
    else
        return a < b;
}
int inf = 1e9;
int main() {
  int n, k;
  cin >> n >> k;
  cnt.resize(k);
  for (int i = 0; i < k; i++)
    cnt[i] = 0;
  vector<vector<int> > hum(n);
  vector<vector<int> > graph(n, vector<int>(n));
  for (int i = 0; i < n; i++){
    int l;
    cin >> l;
    for (int j = 0; j < l; j++){
        int inp;
        cin >> inp;
        inp--;
        cnt[inp]++;
        hum[i].push_back(inp);
    }
  }
  for (int i = 0; i < n; i++){
    sort(hum[i].begin(), hum[i].end(), cmp);
  }

  for (int i = 0; i < n; i++){
    for (int j = 0; j < n; j++){
        if (i == j){
            graph[i][j] = 0;
            continue;
        }
        int i1 = 0, i2 = 0, siz1 = hum[i].size(), siz2 = hum[j].size();
        while(i1 < siz1 && i2 < siz2){
            if (hum[i][i1] == hum[j][i2])
                break;
            if (cnt[hum[i][i1]] < cnt[hum[j][i2]])
                i1++;
            else if (cnt[hum[i][i1]] > cnt[hum[j][i2]])
                i2++;
            else{
                if (hum[i][i1] < hum[j][i2])
                    i1++;
                else
                    i2++;
            }
        }
        if (i1 == siz1 || i2 == siz2)
            graph[i][j] = inf;
        else
            graph[i][j] = cnt[hum[i][i1]] - 1;
    }
  }

  for (int k = 0; k < n; k++){
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            graph[i][j] = min(graph[i][j], graph[i][k] + graph[k][j]);
        }
    }
  }
  for (int i = 0; i < n; i++){
    for (int j = 0; j < n; j++){
        if (graph[i][j] != inf)
            if (graph[i][j] > 0)
                cout << graph[i][j] + 1 << ' ';
            else
                cout << 0 << ' ';
        else
            cout << -1 << ' ';
    }
    cout << endl;
  }
}
