#include <iostream>
#include <vector>
#include <algorithm>

//#define int long long
#define pb push_back
#define len(a) (int)((a).size())
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define f first
#define s second
#define all(a) (a).begin(), (a).end()
#define INF (int)(500239)

using namespace std;

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    int a[n][m];
    forn(i, n) {
        forn(j, m) {
            char c;
            cin >> c;
            a[i][j] = c - 'a';
        }
    }
    int d1[26][n][m];
    int d2[26][n][m];
    forn(i, n) {
        forn(k, 26) {
            int d = INF;
            forn(j, m) {
                d++;
                d1[k][i][j] = d;
                if (a[i][j] == k) d = 0;
            }
            d = INF;
            forn(j, m) {
                d++;
                if (d < d1[k][i][m - j - 1]) d1[k][i][m - j - 1] = -d;
                if (a[i][m - j - 1] == k) d = 0;
            }
        }
    }

    forn(j, m) {
        forn(k, 26) {
            int d = INF;
            forn(i, n) {
                d++;
                d2[k][i][j] = d;
                if (a[i][j] != k) d = 0;
            }
            d = INF;
            forn(i, n) {
                d++;
                if (d2[k][n - i - 1][j] > d) d2[k][n - i - 1][j] = -d;
                if (a[n - i - 1][j] != k) d = 0;
            }
        }
    }
    int q;
    cin >> q;
    forn(l, q) {
        int i, j;
        cin >> i >> j;
        i--; j--;
        int ans = INF, i1, j1;
        forn(k, 26) {
            if (abs(d1[k][i][j]) + abs(d2[k][i][j]) < ans) {
                ans = abs(d1[k][i][j]) + abs(d2[k][i][j]);
                i1 = -d2[k][i][j] + i;
                j1 = -d1[k][i][j] + j;
            }
        }
        if (ans >= INF) {
            cout << -1 << endl;
        }
        else {
            cout << i1 + 1 << ' ' << j + 1 << ' ' << i + 1 << ' ' << j1 + 1 << endl;
        }
    }
    return 0;
}
