#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef double dbl;

int count(ll x) {
	int cnt = 0;

	for (ll i = 1; i <= sqrt(x); i++) {
		if ((x % i) == 0) {
			cnt++;
			if ((x / i) != i) {
				cnt++;
            }
        }
	}

	return cnt;
}

int main() {
	ll x;

	cin >> x;

	if (x > 1e11) {
		cout << x / (ll)(1e9) + 1 << string(9, '0') << "\n";
		return 0;
    }

	for (ll y = x; y <= (ll)((dbl)x / 100. * 101.); y++) {
		if (count(y) >= 100) {
			cout << y << '\n';
			return 0;
        }
    }
	
	cout << "-1\n";

	return 0;
}
