//#include <bits/stdc++.h>
#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <vector>
#include <set>

using namespace std;

#define ll long long

const int maxN = 5005;
const int maxQ = 1000005;
const ll mod = 7 + 1e9;

int A[maxQ];
int B[maxQ];
int C[maxQ];
int D[maxQ];

void read(int* arr, int n, int mod)
{
    int k;
    cin >> k;
    for(int i = 0; i < k; i++) cin >> arr[i];
    for(int i = k; i < n; i++)
    {
        arr[i] = (10007LL * arr[i-2] + 10009LL * arr[i-1] + 87277LL) % mod;
    }
}

int arr1[maxN];
int arr2[maxN];

int arr[maxN][maxN];

int main()
{
    //freopen("in.in", "r", stdin);

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int h, w, q;
    cin >> h >> w >> q;

    string query;
    cin >> query;

    for(int y = 0; y < h; y++)
    {
        for(int x = 0; x < w; x++)
        {
            arr[y][x] = y * w + x;
        }
    }

    read(A, q, h);
    read(B, q, w);
    read(C, q, h);
    read(D, q, w);

    for(int i = 0; i < h; i++) arr1[i] = i;
    for(int i = 0; i < w; i++) arr2[i] = i;

    for(int i = 0; i < q; i++)
    {
        char c;
        c = query[i];

        if(c == 'c')
        {
            swap(arr2[B[i]], arr2[D[i]]);
        }
        else if(c == 'r')
        {
            swap(arr1[A[i]], arr1[C[i]]);
        }
        else if(c == 'f')
        {
            swap(arr[arr1[A[i]]][arr2[B[i]]], arr[arr1[C[i]]][arr2[D[i]]]);
        }
    }

    ll ans = 0, st17 = 1;
    for(int y = 0; y < h; y++, st17 = (st17 * 17)%mod)
    {
        ll st19 = 1;
        for(int x = 0; x < w; x++, st19 = (st19 * 19)%mod)
        {
            ans = (ans + (((arr[arr1[y]][arr2[x]] * st17) % mod) * st19) % mod) % mod;
        }
    }
    cout << ans << endl;



    return 0;
}
