//#include <iostream>
//#include <set>
//#include <deque>
//#include <cstdlib>
//#include <string>
//#include <vector>
//#include <algorithm>
//#include <cstring>
//#include <ctime>
//#include <map>
//
//using namespace std;
//
//typedef long long ll;
//
//#define TL clock() * 1.0 / CLOCKS_PER_SEC
//
//ll solve();
//
//void C();
//
//ll main(){
//  //solve();
//#ifdef _DEBUG
//  //  freopen("in.txt", "r", stdin);
//  //  freopen("out.txt", "w", stdout);
//#endif
//  C();
//  return 0;
//}
//
//
//map<ll, ll> w;
//
//
//ll ask(ll q){
//  if (w.count(q)){
//      return w[q];
//  }
//  else{
//      ll a;
//      cout << "? " << q << endl;
//      cin >> a;
//      w[q] = a;
//  }
//}
//
//void C() {
//  ll x, M;
//  cin >> x >> M;
//  ll l = 0;
//  ll r = M + 1;
//  ll m;
//  ll px = x;
//  x -= ask(1);
//  while (r - l > 1){
//      m = r + l >> 1ll;
//      if (ask(x - m) > px){
//          l = m;
//      }
//      else{
//          r = m;
//      }
//  }
//  cout << "! " << x - r;
//}

#include <iostream>
#include <set>
#include <deque>
#include <cstdlib>
#include <string>
#include <vector>
#include <algorithm>
#include <cstring>
#include <ctime>
#include <map>

using namespace std;

typedef long long ll;

#define TL clock() * 1.0 / CLOCKS_PER_SEC

ll solve();

ll C();

int main(){
	//solve();
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	C();
	return 0;
}

vector<ll> V;
bool A[1000006];
ll SP[1000006];
ll dp[1000006];

ll C() {
	ll N, M, K;
	cin >> N >> K >> M;

	for (ll i = 0; i < M; i++) {
		ll a;
		cin >> a;
		V.push_back(a);
	}

	sort(V.begin(), V.end());

	for (ll i = 0; i <= M + 1; i++) {
		SP[i] = i + 1;
	}

	for (ll i = M - 1; i >= 0; i--) {
		ll k = upper_bound(V.begin(), V.end(), V[i] + K) - V.begin();
		dp[i] = min(dp[k] + K - (SP[k] - SP[i - 1] - 1), N - V[i]);
	}

	ll ans = 1e18;
	ll first = V[0];
	ll last = 0;
	for (ll i = 0; i < M && V[i] - first <= K; i++) {
		last = i;
		ans = min(ans, dp[i] + V[i] - first - SP[i] + 1);
	}

	if (last + 1 < M && V[last] - first != K) {
		ans = min(ans, dp[last + 1] + K - SP[last + 1]);
	}



	cout << N - SP[M - 1] - ans;
	return 0;
}