#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int n, m;
vector <string> v;
vector < vector <int> > lettersRow[26];
vector < vector <int> > noletCol[26];

inline int nearest(const vector <int>& v, int x) {
    int ans = -123456789;
    auto upper = upper_bound(v.begin(), v.end(), x);
    if (upper != v.end())
        ans = *upper;
    auto lower = lower_bound(v.begin(), v.end(), x);
    if (lower != v.begin()) {
        lower--;
        int q = *lower;
        if (q < x && abs(x - q) < abs(x - ans))
            ans = q;
    }
    return ans;
}

int main() {
/*
    int n; cin >> n;
    vector <int> v(n);
    for (int i = 0; i < n; i++) cin >> v[i];
    for (;;) {
        int x; cin >> x;
        cout << nearest(v, x) << endl;
    }

    return 0;
*/
    ios_base::sync_with_stdio(false);
    cin >> n >> m;
    v.resize(n);
    for (int i = 0; i < 26; i++) {
        lettersRow[i].resize(n);
        //noletRow[i].resize(n);
        //lettersCol[i].resize(m);
        noletCol[i].resize(m);
    }
    for (int i = 0; i < n; i++)
        cin >> v[i];
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            for (int k = 0; k < 26; k++)
                if (v[i][j] == k + 'a') {
                    lettersRow[k][i].push_back(j);
                    //lettersCol[k][j].push_back(i);
                } else {
                    //noletRow[k][i].push_back(j);
                    noletCol[k][j].push_back(i);
                }
    int q; cin >> q;
    for (int i = 0; i < q; i++) {
        int a, b; cin >> a >> b; a--, b--;

        int ax = -1, ay = -1, ansC = 2345678;
        for (int k = 0; k < 26; k++) {
            int q1 = nearest(lettersRow[k][a], b);
            int q2 = nearest(noletCol[k][b], a);
            int tmp = abs(q1 - b) + abs(q2 - a);
            if (tmp < ansC) {
                ax = q1;
                ay = q2;
                ansC = tmp;
            }
        }
        if (ax < 0 || ay < 0) {
            cout << -1;
        } else {
            cout << a+1 << " " << ax+1 << " " << ay+1 << " " << b+1;
        }
        cout << "\n";
    }
    return 0;
}
