#include <iostream>

using namespace std;

int h, w, n;
int tab[5001][5001];

int cWhere[5001], rWhere[5001];

const int maxN = 1234567;

int a[maxN], b[maxN], c[maxN], d[maxN];

void inArr(int* a, int r) {
    int k; cin >> k;
    for (int i = 0; i < k; i++)
        cin >> a[i];
    for (int i = k; i < maxN; i++)
        a[i] = (10007LL * a[i-2] + 10009LL * a[i-1] + 87277) % r;
}

int main() {
    cin >> h >> w >> n;
    string s; cin >> s;
    for (int i = 0; i < h; i++)
        for (int j = 0; j < w; j++)
            tab[i][j] = i * w + j;
    for (int i = 0; i < 5001; i++)
        rWhere[i] = cWhere[i] = i;
    inArr(a, h);
    inArr(b, w);
    inArr(c, h);
    inArr(d, w);
    for (int i = 0; i < (int)s.length(); i++) {
        if (s[i] == 'r') {
            swap(rWhere[a[i]], rWhere[c[i]]);
        } else if (s[i] == 'c') {
            swap(cWhere[b[i]], cWhere[d[i]]);
        } else {
            swap(tab[rWhere[a[i]]][cWhere[b[i]]],
                 tab[rWhere[c[i]]][cWhere[d[i]]]);
        }
    }
    const int mod = (int)1e9 + 7;
    int checkSum = 0;
    long long p17 = 1;
    for (int i = 0; i < h; i++) {
        long long p19 = 1;
        for (int j = 0; j < w; j++) {
            checkSum = (checkSum + ((tab[rWhere[i]][cWhere[j]] * p17) % mod) * p19) % mod;
            p19 = (p19 * 19) % mod;
        }
        p17 = (p17 * 17) % mod;
    }
    cout << checkSum << endl;
    return 0;
}

