#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

long main()
{
	ios::sync_with_stdio(0);
	int n, k, m;
	cin >> m >> k >> n;
	vector<int> a(n);
	for (int &i : a)
		cin >> i;
	a.push_back(-1e9);
	sort(a.begin(), a.end());
	vector<int> dp(n + 1);
	dp[0] = 0;
	for (int i = 1; i <= n; i++)
	{
		if (a[i] <= k)
			dp[i] = a[i];
		else
			dp[i] = dp[upper_bound(a.begin(), a.end(), a[i] - k) - a.begin() - 1] + k;
	}
	int ans = m - dp[n];
	//for (int i = 0; i <= n; i++)
	//	cerr << dp[i] << " ";
	//cerr << "\n";
	for (int i = n; i > 0; i--)
		if (a[i] + k > m)
		{
			//cerr << i << " : ";
			//cerr << a[i] << " " << dp[i - 1] << "\n";
			ans = max(ans, a[i] - 1 - dp[i - 1]);
		}
	cout << ans;
	return 0;
}