#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

const int MAXN = 3e2 + 10;

vector <int> v[MAXN];

int lang[MAXN][MAXN];
int p[MAXN];

int w[MAXN][MAXN];

int main() {
	//freopen("TEST.txt", "r", stdin);
	ios::sync_with_stdio(0);
	int n, m; cin >> n >> m;
	for (int i = 0; i < n; i++) {
		int k; cin >> k;
		v[i].resize(k);
		for (int j = 0; j < k; j++) {
			cin >> v[i][j];
			p[v[i][j]]++;
		}
		sort(v[i].begin(), v[i].end());
	}

	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++) {
    		int u2 = 0;
			int answer = 1e9;
			if (i == j)
				answer = 0;
			for (int u1 = 0; u1 < int(v[i].size()); u1++) {
				while (u2 < int(v[j].size()) && v[j][u2] < v[i][u1])
					u2++;
				if (u2 < int(v[j].size()) && v[j][u2] == v[i][u1])
					answer = min(answer, p[v[j][u2]]);
			}

			w[i][j] = answer;
		}

	//for (int i = 0; i < n; i++) {
	//	for (int j = 0; j < n; j++) {
	//		if (w[i][j] < 1e9)
	//			cout << w[i][j] << " ";
	//		else
	//			cout << -1 << " ";
	//	}
	//	cout << endl;
	//}

	for (int k = 0; k < n; k++)
		for (int i = 0; i < n; i++)
			for (int j = 0; j < n; j++)
				if (i != j && i != k && j != k)
    				w[i][j] = min(w[i][j], w[i][k] + w[k][j] - 1);

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {

			if (w[i][j] < 1e9)
				cout << w[i][j] << " ";
			else
				cout << -1 << " ";
		}
		cout << endl;
	}

	return 0;
}