#include <string>
#include <iostream>
#include <vector>

using namespace std;

string s[1000002];

vector<int> dl[1000002], dr[1000002], du[1000002], dd[1000002];

int main() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		string ss;
		cin >> ss;
		s[i + 1] = " " + ss + " ";
		dl[i].resize(m + 4);
		dr[i].resize(m + 4);
		du[i].resize(m + 4);
		dd[i].resize(m + 4);
	}
	dl[n].resize(m + 4);
	dr[n].resize(m + 4);
	du[n].resize(m + 4);
	dd[n].resize(m + 4);
	dl[n + 1].resize(m + 4);
	dr[n + 1].resize(m + 4);
	du[n + 1].resize(m + 4);
	dd[n + 1].resize(m + 4);
	for (int i = 0; i < n + 2; i++) {
		dl[i][0] = 0;
		dr[i][m + 1] = m + 1;
	}
	for (int i = 0; i < m + 2; i++) {
		du[0][i] = 0;
		dd[n + 1][i] = n + 1;
		s[0] += " ";
		s[n + 1] += " ";
	}
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			if (s[i][j] != s[i][j - 1]) {
				dl[i][j] = j - 1;
			}
			else {
				dl[i][j] = dl[i][j - 1];
			}
			if (s[i][j] != s[i - 1][j]) {
				du[i][j] = i - 1;
			}
			else {
				du[i][j] = du[i - 1][j];
			}
		}
	}
	for (int i = n; i > 0; i--) {
		for (int j = m; j > 0; j--) {
			if (s[i][j] != s[i][j + 1]) {
				dr[i][j] = j + 1;
			}
			else {
				dr[i][j] = dr[i][j + 1];
			}
			if (s[i][j] != s[i + 1][j]) {
				dd[i][j] = i + 1;
			}
			else {
				dd[i][j] = dd[i + 1][j];
			}
		}
	}
	int k;
	cin >> k;
	for (int i = 0; i < k; i++) {
		int a, b;
		cin >> a >> b;
		int ans = n + m + 2, x1, x2, y1, y2;
		if (a < n && b < m) {
			if (s[a][b + 1] != s[a + 1][b]) {
				x1 = a;
				x2 = a + 1;
				y1 = b + 1;
				y2 = b;
				ans = 2;
			}
			if (dd[a + 1][b] != n + 1) {
				if (ans > 1 + dd[a + 1][b]) {
					x1 = dd[a + 1][b];
					x2 = a;
					y1 = b;
					y2 = b + 1;
					ans = 1 + dd[a + 1][b];
				}
			}
			if (dr[a][b + 1] != m + 1) {
				if (ans > 1 + dr[a][b + 1]) {
					x1 = a + 1;
					x2 = a;
					y1 = b;
					y2 = dr[a][b + 1];
					ans = 1 + dr[a][b + 1];
				}
			}
		}
		if (a < n && b > 1) {
			if (s[a][b - 1] != s[a + 1][b]) {
				x1 = a;
				x2 = a + 1;
				y1 = b - 1;
				y2 = b;
				ans = 2;
			}
			if (dd[a + 1][b] != n + 1) {
				if (ans > 1 + dd[a + 1][b]) {
					x1 = dd[a + 1][b];
					x2 = a;
					y1 = b;
					y2 = b - 1;
					ans = 1 + dd[a + 1][b];
				}
			}
			if (dl[a][b - 1] != 0) {
				if (ans > 1 + dl[a][b - 1]) {
					x1 = a + 1;
					x2 = a;
					y1 = b;
					y2 = dl[a][b - 1];
					ans = 1 + dl[a][b - 1];
				}
			}
		}
		if (a > 1 && b > 1) {
			if (s[a][b - 1] != s[a - 1][b]) {
				x1 = a;
				x2 = a - 1;
				y1 = b - 1;
				y2 = b;
				ans = 2;
			}
			if (du[a - 1][b] != 0) {
				if (ans > 1 + du[a - 1][b]) {
					x1 = du[a - 1][b];
					x2 = a;
					y1 = b;
					y2 = b - 1;
					ans = 1 + du[a - 1][b];
				}
			}
			if (dl[a][b - 1] != 0) {
				if (ans > 1 + dl[a][b - 1]) {
					x1 = a - 1;
					x2 = a;
					y1 = b;
					y2 = dl[a][b - 1];
					ans = 1 + dl[a][b - 1];
				}
			}
		}
		if (a > 1 && b < m) {
			if (s[a][b + 1] != s[a - 1][b]) {
				x1 = a;
				x2 = a - 1;
				y1 = b + 1;
				y2 = b;
				ans = 2;
			}
			if (du[a - 1][b] != 0) {
				if (ans > 1 + du[a - 1][b]) {
					x1 = du[a - 1][b];
					x2 = a;
					y1 = b;
					y2 = b + 1;
					ans = 1 + du[a - 1][b];
				}
			}
			if (dr[a][b + 1] != m + 1) {
				if (ans > 1 + dr[a][b + 1]) {
					x1 = a - 1;
					x2 = a;
					y1 = b;
					y2 = dr[a][b + 1];
					ans = 1 + dr[a][b + 1];
				}
			}
		}
		if (ans == n + m + 2) {
			cout << -1 << '\n';
		}
		else {
			cout << x1 << ' ' << y1 << ' ' << x2 << ' ' << y2 << '\n';
		}
	}
}
